EnableExplicit

;IncludeFile "..\..\..\..\LibBuildPB\LibBuild.pb"
;LibBuild_Add(TxtFileReader_FromFile)
;LibBuild_Add(TxtFileReader_ParseLines)

#LyricSupport = 2 
#LSExternal = 0
#LSTesting = 0
CompilerIf #LSTesting
  #SetToForeGround = 0
  CompilerElse
  #SetToForeGround = #HWND_TOPMOST ; #HWND_TOPMOST or 0
  CompilerEndIf
#FixedWidth =  0;640      ;960/1280
#FixedHeight = 0;360/480 ;720
#NoPlayerDet = 0 ; not very optimized!!! - for testing

#SilvesterSupport = 1
#HiddenChk = 1
#NoWarnOrQuitHack = 1

; Copyright (C) 2007-2011 Jan Vorel
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; If you have any questions, suggestions or bug reports about this product,
; contact me: info@ctuser.net; Do not contact me about general B.A.S.I.C.
; language or A.P.I. issues





; Wavedata To spectrum Data conversation is based on a free Visual Basic 6
; example by Ulli "Mhlenweg" <umgedv@yahoo.com>, which can be found at
; http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=65007&lngWId=1



;#MMonitor = 1


;IncludeFile "Pre.pb"

;IncludeFile("LineSpec.pb")
;IncludeFile("LineSpecMultithread.pb")
;IncludeFile("LineSpecClient.pb")
;IncludeFile("..\Stuff\LineSpec (purebasic version).pb")

Macro InvertRGBConst(Constant)
  ((Constant & $ff) << 16) | (Constant & $ff00) | ((Constant & $ff0000) >> 16)
  EndMacro

  CompilerIf #PB_Compiler_Unicode
    Procedure.i GetProcAddress(*xLib, xName.s)
      PokeS(*ptrTemp, xName, -1, #PB_Ascii)
      ProcedureReturn GetProcAddress_(*xLib, *ptrTemp)
      EndProcedure
    CompilerElse
    Macro GetProcAddress(xLib, xName)
      GetProcAddress_(xLib, xName)
      EndMacro
    CompilerEndIf


CompilerIf #LSExternal = 0 Or #LSTesting
  CompilerIf #LSTesting
    ;IncludeFile("..\..\Source\Virtual\LineSpec (VirtualX).pb")
    IncludeFile("..\..\Source\LineSpec.pb")
    CompilerElse
    IncludeFile("..\..\Source\LineSpec.pb")
    CompilerEndIf
  CompilerElse

  Procedure.l LineSpec_PBLoader()
    Global *LSStartup
    Global *LSGetSpectrum
    Global *LSShutdown

    Define.i hLib = LoadLibrary_("d:\dev\software\libraries\linespec\linespec.dll")
    If hLib
      *LSStartup = GetProcAddress(hLib, "Startup")
      *LSGetSpectrum = GetProcAddress(hLib, "GetSpectrum")
      *LSShutdown = GetProcAddress(hLib, "Shutdown")
      If *LSStartup And *LSGetSpectrum And *LSShutdown
        ProcedureReturn 1
        EndIf
      FreeLibrary_(hLib)
      EndIf
    EndProcedure

  Procedure.i LineSpec_Startup(Flags.i)
    ProcedureReturn CallFunctionFast(*LSStartup, Flags)
    EndProcedure

  Procedure.i LineSpec_GetSpectrum(*xSingleArray1, ArraySize.i, Stereo.i, Flags.i, *Boost)
    ProcedureReturn CallFunctionFast(*LSGetSpectrum, *xSingleArray1, ArraySize, Stereo, Flags, *Boost)
    EndProcedure
  
  Procedure LineSpec_Shutdown()
    ProcedureReturn CallFunctionFast(*LSShutdown)
    EndProcedure
  
  DataSection
    CritSection:
    !CritSection:
    !DD 0, 0, 0, 0, 0, 0
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
!  DD 0, 0, 0, 0, 0, 0
CompilerEndIf
    EndDataSection
  CompilerEndIf


Import "KERNEL32.lib"
  CreateFileW.i(*Filename, *p1, *p2, *p3, *p4, *p5, *p6)
  lstrlenW.i(*Mem)
  EndImport
Import "GDI32.lib"
  TextOutW.i(DC.i, X.i, Y.i, ptrString.i, LenString.i)
  GetTextExtentPoint32W(hDC, ptrString, LenString, ptrRect)
  EndImport
Import "USER32.lib"
  SendMessageW.i(hWnd.i, Msg.i, wParam.i, lParam.i)
  EndImport

#FullBMPRes = 0

Declare CalcAndDrawInfoPos()
Declare TrayIconChanged()
Declare WMFTray()
Declare RenderTray()
Declare RestoreTray()
CompilerIf #HiddenChk
CompilerIf #HiddenChk = 2
Declare HiddenCheck()
CompilerElse
Declare.i HiddenCheck()
Declare.l ShowMeThread()
CompilerEndIf
CompilerEndIf

Global AutoHidden.l
Global IsVistaOrNewer.l

Global hBrush_SPosC.i
Global hBrush_SPosT.i
Global xTxtLastLeft.i
Global xTxtLastTop.i

Global TrayIconSizeX.i
Global TrayIconSizeY.i
Global hBrush.i
Global hBrush_Green.i
Global hBrush_Yellow.i
Global hBrush_Red.i
Global xMenu.i
Global SSAutoQuit.l
Global SSPreview.i


;Global HookIt.l = 1

CompilerIf #AnimPlugin
  CompilerElse
  #PSFMode = 0
  #RenderSelf = 0
;  #WarnMsg = 1
  #FixedUse = 0
  #MMonitor = 1
  Declare GetFrameFromSpectrum(Advance.l, *SpectrumArray, *FrameArray)

  Global RGBMulX_Result.l
  Global Dim xCurSpec.f(5)
  Global xCurrentFrame.l
  Global xFrameCount.l

  Global MaxInit.l = 5
  CompilerEndIf

CompilerIf #RenderSelf = 2
  Global ExcludeTop.l
  CompilerIf #AnimPlugin = 1
    CompilerElse
    Global ExcludeBottom.l
    CompilerEndIf
  CompilerEndIf
Global IsSaving.l
Global LastMoved.l
  Global LastMPos.RECT


;Structure MONITORINFO
;  cbSize.i
;  rcMonitor.RECT
;  rcWork.RECT
;  dwFlags.i
;  EndStructure

Structure TxtFileReadStruct
  hMem.i
  ; Same position as in Write Struct!!!!
  Encoding.i
  hMemPos.i
  hMemEnd.i
  LastPos.i
  LastEnd.i
  EndStructure

#TimeIntervalMs = 3 * 60 * 1000
#TimeIntervalMsX = #TimeIntervalMs * 4


#BorderForImage = 8

#ReFlag2xxa = #SWP_NOACTIVATE | #SWP_SHOWWINDOW | #SWP_NOMOVE | #SWP_NOSIZE

CompilerIf #FixedUse
  Global InfoWidthMax.l
  CompilerEndIf

;Global hRegion.l
Global NowHidden.l
Global OrgTrayIcon.i
Global hIS.ICONINFO
Global RenderedTrayIcon.i
Global HasIcon.i
Global hInstance.i = GetModuleHandle_(0)
CompilerIf #RenderSelf
  CompilerElse
  Global *xFrames
  #WarnMsg = 1
  #WarnQuit = 0
  #HAlign = 1
  CompilerEndIf
Global xMainHWnd.i
Global xMainDC.i
;Global xMyWin.RECT
Global FullWindow_W.l
Global FullWindow_H.l
Global PicSizeX.l
Global PicSizeXC.l
Global PicSizeXO.l
Global InfoDlg.i

#BorderForImageX2 = #BorderForImage * 2

CompilerIf #RenderSelf
  CompilerIf #StereoBMP
    #InfoIntHeight = 48 ;#PicSizeH
    #SpectrumRedrawInfo = 0
    CompilerElse
    CompilerIf #CustomPeakRender
      #InfoIntHeight = 48
      #SpectrumRedrawInfo = #True
      CompilerElse
      CompilerIf #SpectrumRedrawInfo
        #InfoIntHeight = #SizeTY + 8 ;66
        CompilerElse
        #InfoIntHeight = 50 + #SizeTY
        CompilerEndIf
      CompilerEndIf
    CompilerEndIf
  CompilerElse
  #InfoIntHeight = 48
  #SpectrumRedrawInfo = 0
  CompilerEndIf

;#PicSizeH = 48
;CompilerIf #SpectrumRedrawInfo
;  #InfoIntHeight = 66
;  CompilerElse
;  CompilerIf #RenderSelf
;    CompilerIf #StereoBMP
;      #InfoIntHeight = 48 ;#PicSizeH
;      CompilerElse
;      ;#InfoIntHeight = 80
;      #InfoIntHeight = 50 + #SizeTY
;      CompilerEndIf
;    CompilerElse
;    #InfoIntHeight = 48
;    CompilerEndIf
;  CompilerEndIf

;#PicSizeHET = #PicSizeH + 2 * #BorderForImage
CompilerIf #CustomPeakRender
  CompilerElse
  #PicSizeYOX = #InfoIntHeight + #BorderForImageX2
  CompilerEndIf

CompilerIf #FixedUse = 1
  Global InfoWidthGen.l
  CompilerElse
  Global FullWindow_WMove.l
  ;Global gImage.l
  CompilerIf #HAlign = 1
    Global FullWindowW.l
    CompilerElse
    Global FullWindowH.l
    CompilerEndIf
  Global InfoLeft.l
  Global InfoTop.l
  Global InfoIs.l
  CompilerIf #HAlign = 1
    Global InfoOut.l
    ;CompilerElse
    ;Global InfoIn.l
    CompilerEndIf
  Global InfoFirst.l = 1
  CompilerEndIf
;Global hCloseWin.l
;Global sLong1.l
Global LastDeskPos.RECT
Global hFontTitle.i
Global hFontLarge.i
;Global hIcon.i
Global hIconQP.i
Global hIconWA.i
Global hIconAP.i
Global hIconFO.i
Global hWinFoobar.i
CompilerIf #SilvesterSupport
  Global hIconSS.i
  Global OldSilversterTimerText.s
  CompilerEndIf
CompilerIf #LyricSupport
  Global OldLyricLine.i = -1
  Global MemTxtOldCalaymX.i
  Global OldTxtLenX.i
  Global Dim LyricLines.i(998)
  Global Dim LyricTimes.i(999)
  Global LyricCount.i
  Global OldLyricWidthPX.i
  CompilerEndIf

Structure TextBmpType
  Text1.i
  Text1L.i
  Text1X.l
  Text1Y.l
  Text2.i
  Text2L.l
  Text2X.l
  Text2Y.l
  hIcon.i
  ;hIconX.l
  hIconY.i
  xMode.i
  Text2W.l
  ProgCur.i
  ProgTot.i
  EndStructure


Global *hBitmapGen.TextBmpType
Global *hBitmapTxt.TextBmpType

;#TxtMover = 1
CompilerIf #FixedUse = 1
  CompilerElse
  Global *hBitmapNxt.TextBmpType
  Global hBitmapNxtWait.i
  Global hBitmapNxtX.i
  CompilerEndIf

Global NowPlay.s
;Global NowTrack.s
Global MemTxtOld.i
Global MemTxtTemp.i
Global hMapFileViewQP.i
Global hMapFileViewWA.i
Global hMapFileID.i
Global Skipper.l
;Global IsVisible.l
Global TNotIcon.NOTIFYICONDATA
;Global xWinRectMin.RECT
;Global xWinRectClose.RECT
;Global MMonitor.l

Global FakeSaverMode.l

;Global *GetMonitorInfo
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  CompilerElse
  Global *EnumDisplayMonitors
  CompilerEndIf

Procedure.l DeleteTextObject(*xType1.TextBmpType)
  ;If *xType1
    FreeMemory(*xType1\Text2)
    FreeMemory(*xType1\Text1)
    FreeMemory(*xType1)
  ;  EndIf
  EndProcedure

Procedure.i SetProcessDPIAware()
  Define.i xLong1
  xLong1 = GetModuleHandle_("user32.dll")
  If xLong1
    xLong1 = GetProcAddress(xLong1, "SetProcessDPIAware")
    If xLong1
      CallFunctionFast(xLong1)
      EndIf
    EndIf
  EndProcedure



Procedure.s LoadResStringA(ResID.l)
  Define.i xLong1
  Define.s xChar1

  xChar1 = Space(32766)
  xLong1 = LoadString_(hInstance, ResID, @xChar1, 32766)
  If xLong1
    xChar1 = Left(xChar1, xLong1)
    ProcedureReturn xChar1
    EndIf
  EndProcedure

CompilerIf 0
Procedure MakeFilePartW(ptrString.l)
  Define.l xLong1 = ptrString
  Define.l xLong2
  Repeat
    Select PeekW(xLong1)
      Case 0
        Break
      Case 92
        xLong2 = xLong1
      EndSelect
    xLong1 + 2
    ForEver
  If xLong2
    RtlMoveMemory_(ptrString, xLong2 + 2, xLong1 - xLong2)
    EndIf
  EndProcedure
CompilerEndIf

Procedure.l GetTrayDepth()
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    Define.OSVERSIONINFO xType1
    
    xType1\dwOSVersionInfoSize = 148
    If GetVersionEx_(@xType1)
      If (xType1\dwPlatformId = $2)
        If xType1\dwMajorVersion > 6 Or xType1\dwMajorVersion = 6 And xType1\dwMinorVersion >= 1
          IsVistaOrNewer = 1
          EndIf
        EndIf
      EndIf
    ProcedureReturn 1
    CompilerElse
    Define.OSVERSIONINFO xType1
    Define.i hDC ;xLong1
    Define.l xResult
    Global IsUnicode.l
    
    xType1\dwOSVersionInfoSize = 148
    If GetVersionEx_(@xType1)
      If (xType1\dwPlatformId = $2)
        IsUnicode = 1
        EndIf
      hDC = GetDC_(0)
      If hDC
        If GetDeviceCaps_(hDC, 12) > 15
          If (xType1\dwPlatformId = $2)
            If xType1\dwMajorVersion > 5 Or xType1\dwMajorVersion = 5 And xType1\dwMinorVersion >= 1
              xResult = 1
              If xType1\dwMajorVersion > 6 Or xType1\dwMajorVersion = 6 And xType1\dwMinorVersion >= 1
                IsVistaOrNewer = 1
                EndIf
              EndIf
            ElseIf xType1\dwMajorVersion > 4 Or xType1\dwMajorVersion = 4 And xType1\dwMinorVersion >= 90
            xResult = 1
            EndIf
          Else
          EndIf
        ReleaseDC_(0, hDC)
        EndIf
      EndIf
    ProcedureReturn xResult
    CompilerEndIf
  EndProcedure

CompilerIf #AnimPlugin = 0
  Procedure RGBMulX (RGBValue.l, Panel.l)
    Define.l sLong1
    ;blue / low
    sLong1 = ((RGBValue & $FF0000) / $10000) * xCurSpec(0 + Panel * 3)
    If sLong1 < 0
      sLong1 = 0
      ElseIf sLong1 > $FF
      sLong1 = $FF
      EndIf
    RGBMulX_Result = sLong1 * $10000
    
    ;green / med
    sLong1 = ((RGBValue & $FF00) / $100) * xCurSpec(1 + Panel * 3)
    If sLong1 < 0
      sLong1 = 0
      ElseIf sLong1 > $FF
      sLong1 = $FF
      EndIf
    RGBMulX_Result + sLong1 * $100
    
    ;red / high
    sLong1 = (RGBValue & $FF) * xCurSpec(2 + Panel * 3)
    If sLong1 < 0
      sLong1 = 0
      ElseIf sLong1 > $FF
      sLong1 = $FF
      EndIf
    RGBMulX_Result + sLong1
    EndProcedure
  CompilerEndIf


CompilerIf #AnimPlugin
  Declare AnimateFullWin(SkipFrame.l)
  CompilerElse
  Declare AnimateFullWin()
  CompilerEndIf

CompilerIf #FixedUse
CompilerElse
Procedure EraseBkGndSelf()
  Define.RECT xType1

  GetClientRect_(xMainHWnd, @xType1)
  FillRect_(xMainDC, @xType1, hBrush)
  EndProcedure
CompilerEndIf

CompilerIf 0
Procedure GetOptMonitorFromPoint(x.l, y.l, *RectMonitor)
  Define.i xLong1
  Define.MONITORINFO xType2
  
  SystemParametersInfo_(48, 0, *RectMonitor, 0)
;;;;  On Error Goto NoMMApiEr
  xLong1 = MonitorFromPoint_(x, y, 2)
;;;  On Error Goto 0
  If xLong1
    xType2\cbSize = SizeOf(xType2)
    If GetMonitorInfo_(xLong1, @xType2)
      RtlMoveMemory_(*RectMonitor, xType2\rcWork, 16)
      EndIf
    EndIf
  
;NoMMApiRs:
;  On Error Goto 0
;  Exit SUB
;  
;NoMMApiEr:
;  Resume NoMMApiRs
  EndProcedure

Procedure WindowToCursorPos(*xWindowSize.POINT, *xType1.POINT)
  Define.i hCursor ; xLong1
  Define.l xCursorPlusX
  Define.l xCursorPlusX2
  Define.l xCursorPlusY
  Define.l xCursorPlusY2
  Define.RECT xType2
  Define.ICONINFO xType3

  GetCursorPos_(*xType1)
  GetOptMonitorFromPoint(*xType1\X, *xType1\Y, @xType2)
  
  hCursor = LoadCursor_(0, $7F00)
  GetIconInfo_(hCursor, @xType3)
  If xType3\hbmMask: DeleteObject_(xType3\hbmMask): EndIf
  If xType3\hbmColor: DeleteObject_(xType3\hbmColor): EndIf
  
  
  If xType3\xHotspot > 16
    xCursorPlusX = 36 - xType3\xHotspot
    xCursorPlusX2 = 16
    Else
    xCursorPlusX = 16
    xCursorPlusX2 = 4 + xType3\xHotspot
    EndIf
  If xType3\yHotspot > 16
    xCursorPlusY = 36 - xType3\yHotspot
    xCursorPlusY2 = 16
    Else
    xCursorPlusY = 16
    xCursorPlusY2 = 4 + xType3\yHotspot
    EndIf
    
    
  If *xType1\X + *xWindowSize\X + xCursorPlusX > xType2\Right
    *xType1\X - *xWindowSize\X - xCursorPlusX2
    If *xType1\X + *xWindowSize\X > xType2\Right
      *xType1\X = xType2\Right - *xWindowSize\X
      EndIf
    Else
    *xType1\X + xCursorPlusX
    EndIf
    
  If *xType1\Y + *xWindowSize\Y + xCursorPlusY > xType2\Bottom
    *xType1\Y - *xWindowSize\Y - xCursorPlusY2
    If *xType1\Y + *xWindowSize\Y + xCursorPlusY > xType2\Bottom
      *xType1\Y = xType2\Bottom - *xWindowSize\Y
      EndIf
    Else
    *xType1\Y + xCursorPlusY
    EndIf
  If *xType1\X < xType2\Left: *xType1\X = xType2\Left: EndIf
  If *xType1\Y < xType2\Top: *xType1\Y = xType2\Top: EndIf
  EndProcedure
CompilerEndIf

Procedure.l GetAPIPopupMenu(hWndCaller.i, hMenu.i, hWndControl.i, xControlType.l)
CompilerIf 0
  Define.POINT xType1
  Define.RECT xType2
  Define.l xLong1
  Define.RECT xType4
    
  Define.POINT xMenuSize
  Define.i hWinF ; xLong2
  Define.l xLong3
  Define.i hWnd ; xLong4
  
  Define.l xResult
    
  If hMenu
    hWnd = CreateWindowEx_(0, "STATIC", #Null, $8000003, 0, 0, 32, 32, 0, 0, hInstance, 0)
    SetMenu_(hWnd, hMenu)
    DrawMenuBar_(hWnd)
    SetMenu_(hWnd, 0)
    DrawMenuBar_(hWnd)
    
    xLong1 = GetMenuItemCount_(hMenu)
    GetMenuItemRect_(hWnd, hMenu, xLong1 - 1, @xType2)
    xMenuSize\X = xType2\Right
    xMenuSize\Y = xType2\Bottom
    GetMenuItemRect_(hWnd, hMenu, 0, @xType2)
    If HWndCaller And hWnd: DestroyWindow_(hWnd): EndIf
    
    xMenuSize\X - xType2\Left + GetSystemMetrics_(7) * 2
    xMenuSize\Y - xType2\Top + GetSystemMetrics_(8) * 2
    
    ;If HWndControl = 0
;Debug "InitialMenu: " +Str(xType1\X) + ", " + Str(xType1\Y) + " - " + Str(xMenuSize\X) + ", " + Str(xMenuSize\Y)
      WindowToCursorPos(@xMenuSize, @xType1)
;Debug "OCursorMenu: " +Str(xType1\X) + ", " + Str(xType1\Y) + " - " + Str(xMenuSize\X) + ", " + Str(xMenuSize\Y)
      GetOptMonitorFromPoint(xType1\X, xType1\Y, @xType2)
;Debug "OMonitrMenu: " +Str(xType1\X) + ", " + Str(xType1\Y) + " - " + Str(xMenuSize\X) + ", " + Str(xMenuSize\Y)
    ;  Else
    ;  EndIf
    If xType1\X < xType2\Left: xType1\X = xType2\Left: EndIf
    If xType1\Y < xType2\Top: xType1\Y = xType2\Top: EndIf
    
    If HWndCaller
      xResult = TrackPopupMenuEx_(hMenu, $182, xType1\X, xType1\Y, HWndCaller, 0)
      PostMessage_(HWndCaller, 0, 0, 0)
      Else
      hWinF = GetForegroundWindow_()
      If hWinF
        SetForegroundWindow_(hWnd)
;;;      DoEvents
        SetForegroundWindow_(hWnd)
        EndIf
      xResult = TrackPopupMenuEx_(hMenu, $182, xType1\X, xType1\Y, xLong4, 0)
      If hWnd
        If hWinF And xResult: SetForegroundWindow_(hWinF): EndIf
        DestroyWindow_(hWnd)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
CompilerEndIf

CompilerIf 1
  Define.POINT xType1
  Define.RECT xType2
  Define.i xLong1
  Define.RECT xType4
    
  Define.l xCursorPlusX
  Define.l xCursorPlusX2
  Define.l xCursorPlusY
  Define.l xCursorPlusY2
  Define.ICONINFO xType3
      
  Define.POINT xMenuSize
  ;Define.l xLong2
  Define.l xLong3
  Define.i hWin ; xLong4
    
    ;xControlMode: 10(-12 reserved) -> ListBox
    ; -1-> mouse
    ; 0 -> nospecial
    ; 1 -> centerclient
    
    ;0=SingleSel?
    ;1=extended?
    ;2=checkboxmode?
  If hMenu
    hWin = CreateWindowEx_(0, "STATIC", #Null, 3, 0, 0, 32, 32, 0, 0, hInstance, #Null)
    SetMenu_(hWin, hMenu)
    DrawMenuBar_(hWin)
    SetMenu_(hWin, 0)
    DrawMenuBar_(hWin)
    
    xLong1 = GetMenuItemCount_(hMenu)
    GetMenuItemRect_(hWin, hMenu, xLong1 - 1, xType2)
    xMenuSize\X = xType2\Right
    xMenuSize\Y = xType2\Bottom
    GetMenuItemRect_(hWin, hMenu, 0, xType2)
    xMenuSize\X = xMenuSize\X - xType2\Left
    xMenuSize\Y = xMenuSize\Y - xType2\Top
    xMenuSize\X = xMenuSize\X + GetSystemMetrics_(7) * 2
    xMenuSize\Y = xMenuSize\Y + GetSystemMetrics_(8) * 2
    
    SystemParametersInfo_(48, 0, @xType2, 0)
    
    GetCursorPos_(@xType1)
    xLong1 = LoadCursor_(0, $7F00)
    GetIconInfo_(xLong1, xType3)
    If xType3\hbmMask: DeleteObject_(xType3\hbmMask): EndIf
    If xType3\hbmColor: DeleteObject_(xType3\hbmColor): EndIf
;    DestroyCursor_(xLong1)
    If xType3\xHotspot > 16
      xCursorPlusX = 36 - xType3\xHotspot
      xCursorPlusX2 = 16
      Else
      xCursorPlusX = 16
      xCursorPlusX2 = 4 + xType3\xHotspot
      EndIf
    If xType3\yHotspot > 16
      xCursorPlusY = 36 - xType3\yHotspot
      xCursorPlusY2 = 16
      Else
      xCursorPlusY = 16
      xCursorPlusY2 = 4 + xType3\yHotspot
      EndIf
      
      
    If xType1\X + xMenuSize\X + xCursorPlusX > xType2\Right
      xType1\X = xType1\X - xMenuSize\X - xCursorPlusX2
      If xType1\X + xMenuSize\X + xCursorPlusX > xType2\Right
        xType1\X = xType2\Right - xMenuSize\X
        EndIf
      Else
      xType1\X = xType1\X + xCursorPlusX
      EndIf
      
    If xType1\Y + xMenuSize\Y + xCursorPlusY > xType2\Bottom
      xType1\Y = xType1\Y - xMenuSize\Y - xCursorPlusY2
      If xType1\Y + xMenuSize\Y + xCursorPlusY > xType2\Bottom
        xType1\Y = xType2\Bottom - xMenuSize\Y
        EndIf
      Else
      xType1\Y = xType1\Y + xCursorPlusY
      EndIf
    If xType1\X < xType2\Left: xType1\X = xType2\Left: EndIf
    If xType1\Y < xType2\Top: xType1\Y = xType2\Top: EndIf

      
    If xType1\X < xType2\Left: xType1\X = xType2\Left: EndIf
    If xType1\Y < xType2\Top: xType1\Y = xType2\Top:EndIf
    xLong1 = GetForegroundWindow_()
    SetForegroundWindow_(hWin)
    xLong3 = TrackPopupMenuEx_(hMenu, $182, xType1\X, xType1\Y, hWin, #Null)
    If Not (xLong1 = 0 Or xLong3 = 0)
      SetForegroundWindow_(xLong1)
      PostMessage_(hWin, 0, 0, 0)
      EndIf
    DestroyWindow_(hWin)
    ProcedureReturn xLong3
    EndIf
CompilerEndIf
  EndProcedure

Procedure HideSwap()
  If SSPreview = 0
;Debug "HideSwap()"
CompilerIf #HiddenChk = 2
    HiddenCheck()
CompilerEndIf
    NowHidden = 1 - NowHidden
    If NowHidden
      ShowWindow_(xMainHWnd, 0)
      Else
CompilerIf #HiddenChk
CompilerIf #HiddenChk = 2
CompilerElse
  Define.i xLong1
      If HiddenCheck()
        CreateThread_(0, 0, @ShowMeThread(), 0, 0, @xLong1)
        EndIf
CompilerEndIf
CompilerEndIf

      RestoreTray()
      CompilerIf #PSFMode = 0
        CompilerIf #SetToForeGround = #HWND_TOPMOST
          SetWindowPos_(xMainHWnd, IsSaving * -2 + 1, 0, 0, 0, 0, #ReFlag2xxa)
          CompilerEndIf
        CompilerElse
        SetWindowPos_(xMainHWnd, #SetToForeGround, 0, 0, 0, 0, #ReFlag2xxa)
        CompilerEndIf
      EndIf
    AutoHidden = 0
    EndIf
  EndProcedure

Procedure LaunchSndVol()
  Define.i xLong1
  
  If IsVistaOrNewer
    ShellExecute_(0, 0, "rundll32", "Shell32.dll,Control_RunDLL Mmsys.cpl,,1", ".", 5)
    Else  
    xLong1 = ShellExecute_(0, 0, "sndvol32.exe", "/r", ".", 5)
    If xLong1 >= 0 And xLong1 < 33
      ShellExecute_(0, 0, "sndvol.exe", "/r", ".", 5)
      EndIf
    EndIf
  EndProcedure

Procedure.i InfoDialogProc(hWnd.i, Msg.i, wParam.i, lParam.i)
  Select Msg
    Case #WM_INITDIALOG
      ;SetWindowPos_(hWnd, -1, 0, 0, 0, 0, 
      InfoDlg = hWnd
      hWnd = GetDlgItem_(hWnd, 10)
      If hWnd
        SetFocus_(hWnd)
        EndIf
    Case #WM_CLOSE
      EndDialog_(hWnd, 0)
    Case #WM_COMMAND
      If lParam
        ;If (GetWindowLong(lParam, -16) And $E) = 0
        If (wParam & $ffff) = 10
          EndDialog_(hWnd, 0)
          EndIf
        ElseIf wParam = 2
        EndDialog_(hWnd, 0)
        EndIf
    EndSelect
  EndProcedure

Procedure ProcessMenu(xLong1.l)
  Select xLong1
    Case 10
      If NowHidden
        HideSwap()
        ;NowHidden = 0
        ;RestoreTray()
        ;CompilerIf #PSFMode = 0
        ;  CompilerIf #SetToForeGround = #HWND_TOPMOST
        ;    SetWindowPos_(xMainHWnd, IsSaving * -2 + 1, 0, 0, 0, 0, #ReFlag2xxa)
        ;    CompilerEndIf
        ;  CompilerElse
        ;  SetWindowPos_(xMainHWnd, #SetToForeGround, 0, 0, 0, 0, #ReFlag2xxa)
        ;  CompilerEndIf
        EndIf
      FakeSaverMode = 1
    Case 12: HideSwap()
    ;Case 17: DialogBoxParam_(hInstance, 10, 0, @InfoDialogProc(), 0)
    Case 18: LaunchSndVol()
    Case 19: PostMessage_(xMainHwnd, #WM_QUIT, 0, 0)
    EndSelect
  EndProcedure

Procedure.i MenuThread(Param.i)
  ;ProcessMenu()
  Param = GetAPIPopupMenu(xMainHWnd, xMenu, 0, 0)
  If Param = 17
    DialogBoxParam_(hInstance, 10, 0, @InfoDialogProc(), 0)
    InfoDlg = 0
    EndIf
  EnterCriticalSection_(?CritSection)
  PokeI(?hThreadLSD, 0)
  PokeI(?hThreadRes, Param)
  LeaveCriticalSection_(?CritSection)
  EndProcedure

CompilerIf #HiddenChk
CompilerIf #HiddenChk = 2
CompilerElse
Procedure.l ShowMeThread()
;Debug "Thread..."
  Define.i hWin = CreateWindowEx_(0, "STATIC", #Null, $80000003, 0, 0, 32, 32, 0, 0, hInstance, 0)
  If hWin
;Debug "OK"
    ShowWindow_(hWin, 5)
    SetForegroundWindow_(hWin)

    PostQuitMessage_(0)
    Define.MSG msg
;    Define.l NowPressed
;    Define.l LstTrayTimer = GetTickCount_() & $2000
;    ;Define.l ll
    While GetMessage_(@Msg, 0, 0, 0)
      If msg\message = #WM_QUIT
        Break
        Else
        TranslateMessage_(@msg)
        DispatchMessage_(@msg)
        EndIf
      Wend
    DestroyWindow_(hWin)
    EndIf
;Debug "  leave"
  EndProcedure
CompilerEndIf
CompilerEndIf

Procedure.i FrameWinProc(hWnd.i, Msg.i, wParam.i, lParam.i)
  Select Msg
    Case #WM_ERASEBKGND
      xMainDC = wParam ;GetDC_(xMainHWnd)
;CompilerIf #FixedUse
      EraseBkGndSelf()
;CompilerEndIf
CompilerIf #SpectrumRedrawInfo
CompilerElse
      CalcAndDrawInfoPos()
CompilerEndIf
    Case #WM_MOUSEMOVE
      Select (lParam & $FFFF)
        Case #WM_LBUTTONDOWN ;, #WM_RBUTTONDOWN
          HideSwap()
        Case #WM_LBUTTONDBLCLK ;, #WM_RBUTTONDBLCLK
          PostQuitMessage_(0)
        ;Case #WM_RBUTTONDBLCLK
        ;  LaunchSndVol()
        Case #WM_RBUTTONDOWN
          If PeekI(?hThreadLSD) = 0
            EnterCriticalSection_(?CritSection)
            Msg = CreateThread_(0, 0, @MenuThread(), 0, 0, @wParam)
            If Msg
              PokeI(?hThreadLSD, Msg)
              LeaveCriticalSection_(?CritSection)
              Else
              LeaveCriticalSection_(?CritSection)
              ProcessMenu(GetAPIPopupMenu(xMainHWnd, xMenu, 0, 0))
              EndIf
            ElseIf InfoDlg
;Debug "#" + Str(InfoDlg) + "#"
            ;ShowWindow_(MainHWnd, 9&)
            ShowWindow_(InfoDlg, 9)
            SetForegroundWindow_(InfoDlg)
            ;SetWindowPos(MainHWnd, -1&, 0&, 0&, 0&, 0&, &H213&)
            ;SetWindowPos(MainHWnd, -2&, 0&, 0&, 0&, 0&, &H213&)
            ;ShowWindow_(InfoDlg, 0)
            ;ShowWindow_(InfoDlg, 5)
            EndIf
        EndSelect
;    Case #WM_COMMAND
;      IsSaving = wParam
;    Case #WM_SIZE
;      Debug "WM_SIZE"
;    Case #WM_WINDOWPOSCHANGING
;      Debug "WM_WINDOWPOSCHANGING"
;      If lParam ;And HookIt
;        Define.WINDOWPOS *xType1 = lParam
;        ;*xType1\flags = 0
;        Debug *xType1\hwndInsertAfter
;        Debug *xType1\x
;        Debug *xType1\y
;        Debug *xType1\cx
;        Debug *xType1\cy
;        Debug *xType1\flags = 0
;        EndIf
    Case #WM_CLOSE
      If SSPreview
        ShowWindow_(xMainHWnd, 0)
        SetParent_(xMainHWnd, 0)
        EndIf
      PostQuitMessage_(0)
    Default
      ProcedureReturn DefWindowProc_(HWnd, Msg, wParam, lParam)
    EndSelect
  EndProcedure

Procedure FakeSaverNow()
  LastMoved = GetTickCount_() & $3FFFFFFF
  If LastMoved > #TimeIntervalMs
    LastMoved = 0
    Else
    LastMoved = #TimeIntervalMsX
    EndIf
  GetCursorPos_(@LastMPos)
  EndProcedure

CompilerIf #MMonitor = 2
  Procedure.i DMEnum2(hMonitor.i, hDC.i, *ISRect.RECT, *MustButtom)
    ;Debug "Enum"
    If *ISRect\Top = 0 And *ISRect\Bottom = PeekI(*MustButtom)
      ProcedureReturn 1
      Else
      PokeI(*MustButtom, 0)
      ProcedureReturn 0
      EndIf
    EndProcedure
  CompilerEndIf

CompilerIf #MMonitor ;= 1
  Procedure.i DMEnum(hMonitor.i, hDC.i, *ISRect.RECT, *MyRect)
    ;Debug "Enum"
    If Not (*ISRect\Left =0 And *ISRect\Top = 0)
      ;Debug "EnumOK: " + Str(hMonitor) + " @ " + Str(*ISRect\Left) + ", " + Str(*ISRect\Top)
;*ISRect\Left / 2
;*ISRect\Right / 2
      RtlMoveMemory_(*MyRect, *ISRect, 16)
      ;Global 
      EndIf
    ProcedureReturn 1
    EndProcedure
  CompilerEndIf

CompilerIf #FullBMPRes = 0
  Declare.i TxtToBmp(IconHandle.i, LenLargeTitle.l, Head.s, xMode.i, ProgCur.i, ProgTot.i, LyrMinWidthPX.i)
  CompilerEndIf


;-  Lbl0
SetProcessDPIAware()
Init(0)
#SpecialWindowClassName = "LineSpecDemo_Window"
If FindWindow_(#SpecialWindowClassName, 0) = 0


  Select LCase(ProgramParameter(0))
    Case "/c"
      DialogBoxParam_(hInstance, 10, GetForegroundWindow_(), @InfoDialogProc(), 0)
      End
    Case "/s"
      SSAutoQuit = #True
    Case "/p"
      SSPreview = Val(ProgramParameter(1))
      If SSPreview = 0
        End
        EndIf
    Default
      If LCase(Right(ProgramFilename(), 4)) = ".scr"
        DialogBoxParam_(hInstance, 10, GetForegroundWindow_(), @InfoDialogProc(), 0)
        End
        EndIf
    EndSelect

  
  ;Dim xSingleA1.f(5)
  ;AttachProcess(0)
  
  ;Define.l xMainWindow
  Define.LOGFONT xType1
  
  
  CompilerIf #RenderSelf
    CompilerElse
    CompilerIf #AnimPlugin
      #spx = #SpectrumArraySize * 2 - 1
      Global Dim xCurSpec.f(#spx)
      *xFrames = AllocateMemory(512)
      ;AttachAndStartup()
      CompilerElse
      *xFrames = ?FramesStart + 12
      xFrameCount = (?FramesEnd - *xFrames) / 512
      CompilerEndIf
    CompilerEndIf
  
  CompilerIf #FixedUse
    hBrush = CreateSolidBrush_(#FixedUseBkColor)
    CompilerElse
    CompilerIf #PSFMode
      hBrush = CreateSolidBrush_(#PSFColor)
      CompilerElse
      hBrush = CreateSolidBrush_(0)
;Debug hBrush
      CompilerEndIf
    CompilerEndIf
  
;  MessageRequester("", "1")



;If LibBuild_Init("");"Calaym")
  If hBrush
hBrush_Green = CreateSolidBrush_($00ff00)
If hBrush_Green
  ;hBrush_Yellow = hBrush_Green
  ;hBrush_Red = hBrush_Green
  hBrush_Yellow = CreateSolidBrush_($00ffff)
  If hBrush_Yellow
    hBrush_Red = CreateSolidBrush_($0000ff)
    If hBrush_Red = 0
      hBrush_Red = hBrush_Green
      DeleteObject_(hBrush_Yellow)
      hBrush_Yellow = hBrush_Green
      EndIf
    Else
    hBrush_Yellow = hBrush_Green
    hBrush_Red = hBrush_Green
    EndIf

;hBrush_SPosC = CreateSolidBrush_($d0d0d0)
hBrush_SPosC = CreateSolidBrush_(#ProgressColorCur)
If hBrush_SPosC
  ;hBrush_SPosT = CreateSolidBrush_($505050)
  hBrush_SPosT = CreateSolidBrush_(#ProgressColorTot)
  If Not hBrush_SPosT
    DeleteObject_(hBrush_SPosC)
    EndIf
  EndIf
  

  Global Dim xTrayCurSpec.f(5)
  Global iRect.RECT
  ;iRect\Right = 16
  ;iRect\Bottom = 16



    Define.WNDCLASSEX xType2
  ;MessageRequester("", "2")
  
  ;MessageRequester("", "3")
    ;Define.i hCursor = LoadCursor_(0, $7F00)
;    If hCursor
      Define.s xChar1 = #SpecialWindowClassName
      With xType2
        \cbSize = SizeOf(xType2)
        \hInstance = hInstance
    ;MessageRequester("hInstance", Str(hInstance))
;        \hCursor = hCursor
    ;MessageRequester("hCursor", Str(\hCursor))
        ;CompilerIf #FixedUse
          #CSStyle = #CS_CLASSDC | #CS_VREDRAW | #CS_HREDRAW ;| #CS_PARENTDC
          If SSPreview
            \Style = 0
            Else
            \Style = #CSStyle
            EndIf
        ;  CompilerElse
        ;  \Style = #CS_PARENTDC ; #CS_VREDRAW | #CS_HREDRAW | #CS_PARENTDC ; $83 | 
        ;  \hbrBackground = hBrush
        ;  CompilerEndIf
        \lpfnWndProc = @FrameWinProc()
        \lpszClassName = @xChar1
        EndWith
    ;MessageRequester("RegisterClassEx", Str(RegisterClassEx_(xType2)))
      RegisterClassEx_(xType2)
      
      #Style3 = $88 ;4 | #WS_EX_TOOLWINDOW
      ;#WSStyle2 = $80800000 | #WS_DISABLED
      ;WS_CLIPSIBLINGS 4000000
      ;WS_CLIPCHILDREN 2000000
      ;CompilerIf #FixedUse
      ;  #WSStyle2 = #WS_POPUP | #WS_DISABLED ;| #WS_VISIBLE
      ;  xMainHWnd = CreateWindowEx_(#Style3, #SpecialWindowClassName, "", #WSStyle2, #FixedLeft, #FixedTop, #FixedWidth, #FixedHeight, 0, 0, hInstance, 0)
      ;  CompilerElse
        

      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
        CompilerElse
        *EnumDisplayMonitors = GetModuleHandle_("user32.dll")
        If *EnumDisplayMonitors
          *EnumDisplayMonitors = GetProcAddress(*EnumDisplayMonitors, "EnumDisplayMonitors")
  ;        If *EnumDisplayMonitors
  ;          If CallFunctionFast(*EnumDisplayMonitors, 0, 0, @DMEnum(), @LastMPos)
  ;            If Not LastMPos\Left + LastMPos\Top = 0;+ xType1\Right + xType1\Bottom = 0
  ;              ;Debug "A"
  ;              xMainHWnd = CreateWindowEx_(#Style3, #SpecialWindowClassName, "", #WSStyle2, LastMPos\Left, LastMPos\Top, LastMPos\Right - LastMPos\Left, LastMPos\Bottom - LastMPos\Top, 0, 0, hInstance, 0)
  ;              Goto ManCreate
  ;              EndIf
  ;            EndIf
  ;          EndIf
          EndIf
        CompilerEndIf
      If SSPreview
        xMainHWnd = CreateWindowEx_(0, @xChar1, "", #WS_DISABLED | #WS_CHILD, 0, 0, 32, 32, SSPreview, 0, hInstance, 0)        
        Else
        xMainHWnd = CreateWindowEx_(#Style3, @xChar1, "", #WS_POPUP | #WS_DISABLED | xMainHWnd, 0, 0, 32, 32, 0, 0, hInstance, 0)        
        EndIf
      ;  CompilerEndIf
;      Debug xMainHWnd
;      Debug xChar1
;ManCreate:
;    Sleep_(5000)
      If xMainHWnd
;SSPreview = #True
;Debug 4
    ;MessageRequester("", "3")
        ;xChar1 = "#1" + Str(GetTrayDepth())
        ;If GetTrayDepth()
        ;  OrgTrayIcon = LoadImage_(hInstance, "systray_full", 1, 16, 16, 0)
        ;  EndIf
        GetTrayDepth()
        ;OrgTrayIcon = WMFTray()
        ;If OrgTrayIcon = 0: OrgTrayIcon = LoadImage_(hInstance, "systray_limited", 1, 16, 16, 0): EndIf
        ;If OrgTrayIcon
;Debug 5
    ;MessageRequester("", "4")
          hIconQP = LoadImage_(hInstance, @"disp_calaym", 1, 48, 48, 0)
          hIconWA = LoadImage_(hInstance, @"disp_winamp", 1, 48, 48, 0)
          hIconAP = LoadImage_(hInstance, @"disp_apollo", 1, 48, 48, 0)
          hIconFO = LoadImage_(hInstance, @"disp_foobar2000", 1, 48, 48, 0)
          CompilerIf #SilvesterSupport
            hIconSS = LoadImage_(hInstance, @"disp_newyear", 1, 48, 48, 0)
            CompilerEndIf

          xType1\lfHeight = -11
          xType1\lfWeight = 450
;Debug 6
          xType1\lfQuality = #PROOF_QUALITY
          CompilerIf #HAlign = 1
            CompilerElse
            xType1\lfEscapement = 900
            xType1\lfOrientation = 900
            CompilerEndIf
          PokeS(@xType1\lfFaceName, LoadResStringA(15), 32)
          hFontTitle = CreateFontIndirect_(@xType1)
          If hFontTitle
    ;MessageRequester("", "5")
            CompilerIf #FixedUse
              CompilerIf #SmallerFonts
                xType1\lfHeight = -20
                CompilerElse
                xType1\lfHeight = -25
                CompilerEndIf
              CompilerElse
              xType1\lfHeight = -25
              CompilerEndIf
            hFontLarge = CreateFontIndirect_(@xType1)
            If hFontLarge
    ;MessageRequester("", "6")
              MemTxtOld = AllocateMemory($300)
              If MemTxtOld
CompilerIf #LyricSupport
MemTxtOldCalaymX = AllocateMemory($300)
If MemTxtOldCalaymX
CompilerEndIf
MemTxtTemp = AllocateMemory($300)
If MemTxtTemp
    ;MessageRequester("", "7")
                SetWindowLong_(xMainHWnd, #GWL_EXSTYLE, #WS_EX_TOOLWINDOW)
                hMapFileID = Random($7fffffff)
                Define.i hMapFileQP = CreateFileMapping_(-1, 0, #PAGE_READWRITE, 0, $300, "calaym_" + Str(hMapFileID))
                If hMapFileQP
    ;MessageRequester("", "8")
                  hMapFileViewQP = MapViewOfFile_(hMapFileQP, #FILE_MAP_ALL_ACCESS, 0, 0, $300); 
                  If hMapFileViewQP
    ;MessageRequester("", "9")
                    Define.i hMapFileWA = CreateFileMapping_(-1, 0, #PAGE_READWRITE, 0, $300, "winampshowtitleplugin_" + Str(hMapFileID))
                    If hMapFileWA
    ;MessageRequester("", "10")
                      hMapFileViewWA = MapViewOfFile_(hMapFileWA, #FILE_MAP_ALL_ACCESS, 0, 0, $300); 
                      If hMapFileViewWA
    ;MessageRequester("", "11")
                         Define.i xLong5 ; also later III
                        If RecStart(0)
    ;MessageRequester("", "12")
                          xMenu = LoadMenu_(hInstance, "#10")
                          If xMenu
                            Define.i xPopupMenu = CreatePopupMenu_()
                            If xPopupMenu
                              InsertMenu_(xPopupMenu, -1, 1040, xMenu, #Null)
CompilerIf #WarnMsg And #NoWarnOrQuitHack = 0
  Define.l xQuitNew = MessageBox_(0, LoadResStringA(2), LoadResStringA(1), #WarnMsg)
  If xQuitNew = #IDOK Or xQuitNew = #IDYES
CompilerEndIf
                                ;Define.l xLong5
                                Define.l xLong6
      ReWait:
                                For xLong5 = 0 To 255
                                  ;If (GetAsyncKeyState_(xLong5) & $80000001) = $80000001
                                  If (GetAsyncKeyState_(xLong5) & $8001) = $8001
                                    xLong6 = 1
                                    EndIf
                                  Next
                                If xLong6
                                  xLong6 = 0
                                  Sleep_(1)
                                  Goto ReWait
                                  EndIf
    
                                FakeSaverNow()
                                ;If HasIcon
                                  CompilerIf #FullBMPRes
                                    xLong5 = FindResource_(hInstance, "#10", "#2")
                                    If xLong5
                                      xLong5 = LoadResource_(0, xLong5)
                                      If xLong5
                                        xLong5 = LockResource_(xLong5)
                                        If xLong5
                                          *hBitmapGen = LoadBitmap_(hInstance, "#10")
                                          EndIf
                                        EndIf
                                      EndIf
                                    CompilerElse
                                      xChar1 = LoadResStringA(21)
;MessageRequester("", LoadResStringA(21))
                                      If xChar1
                                        PokeS(MemTxtOld, xChar1, -1, #PB_Unicode)
                                        xLong5 = LoadImage_(hInstance, @"disp_default", 1, 48, 48, 0)
                                        CompilerIf #FixedUse
                                          InfoWidthMax = 1280
                                          CompilerEndIf
                                        CompilerIf #FixedUse = 1
                                          CompilerElse
                                          CompilerIf #HAlign = 1
                                            FullWindowW = 1280
                                            CompilerElse
                                            FullWindowH = 1280
                                            CompilerEndIf
                                          CompilerEndIf
                                        *hBitmapGen = TxtToBmp(xLong5, Len(xChar1), LoadResStringA(20), 0, 0, 0, 0)
                                        ;hBitmapGenW = PicSizeXC
                                        ;If xLong5
                                        ;  DestroyIcon_(xLong5)
                                        ;  EndIf
                                        EndIf
                                    CompilerEndIf
                                  If *hBitmapGen
                                    CompilerIf #FixedUse = 1
                                      InfoWidthGen = InfoWidth
                                      CompilerElse
                                      CompilerEndIf
                                    CompilerIf #FullBMPRes
                                      PicSizeXO = PeekL(xLong5 + 4) ; 64 bit fix +8?
                                      PicSizeXC = PicSizeXO
                                      CompilerElse
                                        PicSizeXO = PicSizeX
                                        PicSizeXC = PicSizeX
                                      CompilerEndIf
                                    If SSPreview
                                      PicSizeXO = 48
                                      PicSizeXC = 48
                                      PicSizeX = 48
                                      EndIf
        CompilerIf #FixedUse
        CompilerElse
    ;                                  #WSStyle1 = #WS_DISABLED | #WS_VISIBLE | #WS_CHILD | #SS_BITMAP
    ;                                  gImage = CreateWindow_( "STATIC", "", #WSStyle1, 0, 0, PicSizeX, #PicSizeH, xMainHWnd, 0, hInstance, 0)
    ;                                If gImage
    ;                                  SendMessage_(gImage, #STM_SETIMAGE, #IMAGE_BITMAP, hBitmapGen)
        CompilerEndIf
                                      ;CompilerIf #FixedUse
                                      ;  ;SetWindowLong_(gImage, #GWL_EXSTYLE, #WS_EX_TOOLWINDOW)
                                        ShowWindow_(xMainHWnd, #SW_SHOWNA)
                                      ;  CompilerEndIf
        
                                      NowPlay = LoadResStringA(30)
                                      ;NowTrack = LoadResStringA(31)

                                      ;#WSStyle3 = $6CC0000 | #WS_VISIBLE | #SS_ICON
                                      ;#WSStyle3 = #WS_VISIBLE | #SS_ICON | #WS_CHILD
                                      
                                      ;hCloseWin = CreateWindowEx_(0, "STATIC", "", #WSStyle3, 0, 0, 48, 48, xMainHwnd, 0, hInstance, 0)
                                      ;SetParent_(hCloseWin, xMainHWnd)
                                      ;If hCloseWin
                                      ;  Define.l hCloseIcon = LoadImage_(hInstance, "#10", 1, 48, 48, 0)
                                      ;  If hCloseIcon
                                      ;    SetWindowLong_(hCloseWin, #GWL_EXSTYLE, #WS_EX_TOOLWINDOW)
                                      ;    ShowWindow_(hCloseWin, 5)
                                      ;    SendMessage_(hCloseWin, #STM_SETIMAGE, #IMAGE_ICON, hCloseIcon)
                                          ;If SetTimer_(xMainHwnd, 0, 500, 0)
                                          ;  If SetTimer_(xMainHwnd, 1, 300000, 0)
    
    
    
    
                                            Define.i HCCDC = GetDC_(xMainHWnd)
                                            If HCCDC
                                              Global hDCTemp.i = CreateCompatibleDC_(HCCDC)
                                              Global hLSBmpOld.i
    
                                              ReleaseDC_(xMainHWnd, HCCDC)
                                              If hDCTemp
    
                                                hLSBmpOld = GetCurrentObject_(hDCTemp, #OBJ_BITMAP)
                                                If hLSBmpOld




Define.i hDC = GetDC_(0)
TrayIconSizeX = GetSystemMetrics_(#SM_CXSMICON)
TrayIconSizeY = GetSystemMetrics_(#SM_CYSMICON)
If hDC
  hIS\hbmColor = CreateCompatibleBitmap_(hDC, TrayIconSizeX, TrayIconSizeY)
  ReleaseDC_(0, hDC)
  EndIf
If hIS\hbmColor
  hIS\hbmMask = CreateBitmap_(TrayIconSizeX, TrayIconSizeY, 1, 1, 0)
  If hIS\hbmMask
    hIS\fIcon = 1
;    Define.RECT xType1
    iRect\Right = TrayIconSizeX
    iRect\Bottom = TrayIconSizeY
    If SelectObject_(hDCTemp, hIs\hBmMask)
      If FillRect_(hDCTemp, @iRect, hBrush)
        If SelectObject_(hDCTemp, hIs\hBmColor)
          OrgTrayIcon = WMFTray()
          If OrgTrayIcon
            SelectObject_(hDCTemp, hLSBmpOld)
            OrgTrayIcon = CreateIconIndirect_(@hIS)
            If OrgTrayIcon
              With TNotIcon
                \cbSize = SizeOf(TNotIcon)
                #TrayStyle = #NIF_ICON | #NIF_MESSAGE | #NIF_TIP  
                \hWnd = xMainHWnd
                \uFlags = #TrayStyle
                \uCallbackMessage = #WM_MOUSEMOVE
                \hIcon = OrgTrayIcon
                PokeS(@TNotIcon\szTip, LoadResStringA(10), 64)
                EndWith
              If SSPreview Or SSAutoQuit
                HasIcon = 1
                Else
                HasIcon = Shell_NotifyIcon_(#NIM_ADD, @TNotIcon)
                EndIf
              If HasIcon
                If SelectObject_(hDCTemp, hIs\hBmColor)
                  If FillRect_(hDCTemp, @iRect, hBrush)
            
      
      
      
      

  ;iRect\Right = 16
  ;iRect\Bottom = 16




    
        CompilerIf #FixedUse
                                            If InitSelf()
        CompilerEndIf
        CompilerIf #FixedUse = 1
        CompilerElse
    ;      InfoIs = InfoLeft
    ;      InfoOut = -PicSizeXC
    ;       InfoFirst = 1
        CompilerEndIf
    
    
    
    
        
                                              Define.MSG msg
                                              Define.l NowPressed
                                              Define.l LstTrayTimer = GetTickCount_() & $2000
                                              ;Define.l ll
CompilerIf #WarnMsg And #NoWarnOrQuitHack = 0
  CompilerIf #WarnQuit
    Global WarnQuitTime.l = GetTickCount_() & $3FFFFFFF
    CompilerEndIf
CompilerEndIf
                                              Repeat
                                              ;While GetMessage_(@msg, #Null, 0, 0)
                                                ;While GetQueueStatus_(#QS_ALLEVENTS)
                                                While PeekMessage_(@Msg, 0, 0, 0, #PM_REMOVE)
                                                ;  GetMessage_(@msg, #Null, 0, 0)
                                                  If msg\message = #WM_QUIT
                                                    Break 2
                                                    Else
                                                    TranslateMessage_(@msg)
                                                    DispatchMessage_(@msg)
                                                    EndIf
                                                  Wend
CompilerIf #HiddenChk
If NowHidden = 0
  If HiddenCheck()
    HideSwap()
    EndIf
  AutoHidden = 1
  ElseIf AutoHidden
  If HiddenCheck() = 0
    HideSwap()
    EndIf
  EndIf
CompilerEndIf
                                                
CompilerIf #WarnMsg And #NoWarnOrQuitHack = 0
  CompilerIf #WarnQuit
    xQuitNew = GetTickCount_() & $3FFFFFFF
    If xQuitNew < WarnQuitTime
      If xQuitNew + $40000000 > WarnQuitTime + #WarnQuit
        PostQuitMessage_(0)
        EndIf
      ElseIf xQuitNew > WarnQuitTime + #WarnQuit
      PostQuitMessage_(0)
      EndIf
    CompilerEndIf
CompilerEndIf
                                               
                                                
                                                If GetAsyncKeyState_($10)
                                                  If GetAsyncKeyState_($11)
                                                    If GetAsyncKeyState_($12)
;                                                     If (GetAsyncKeyState_(68) & $FFFF0000)
                                                      If (GetAsyncKeyState_(68) & $8000)
                                                        If NowPressed = 0
                                                          NowPressed = 1
                                                          HideSwap()
                                                          EndIf
                                                        ;lseIf (GetAsyncKeyState_(76) & $FFFF0000)
                                                        ElseIf (GetAsyncKeyState_(76) & $8000)
                                                        ;SendMessage_(xMainHWnd, #WM_CLOSE, 0, 0)
                                                        PostQuitMessage_(0)
                                                        ;ElseIf (GetAsyncKeyState_(86) & $FFFF0000)
                                                        ElseIf (GetAsyncKeyState_(86) & $8000)
                                                        LaunchSndVol()
                                                        ;ElseIf (GetAsyncKeyState_(70) & $FFFF0000)
                                                        ElseIf (GetAsyncKeyState_(70) & $8000)
                                                        If SSPreview = 0
                                                          If NowHidden ; Or IsIconic_(xMainHWnd)
                                                            HideSwap()
                                                            ;NowHidden = 0
                                                            ;RestoreTray()
                                                            ;CompilerIf #PSFMode = 0
                                                            ;  SetWindowPos_(xMainHWnd, IsSaving * -2 + 1, 0, 0, 0, 0, #ReFlag2xxa)
                                                            ;  CompilerElse
                                                            ;  SetWindowPos_(xMainHWnd, #SetToForeGround, 0, 0, 0, 0, #ReFlag2xxa)
                                                            ;  CompilerEndIf
                                                            EndIf
                                                          FakeSaverMode = 1
                                                          EndIf
                                                        Else
                                                        NowPressed = 0
                                                        EndIf
                                                      Else
                                                      NowPressed = 0
                                                      EndIf
                                                    Else
                                                    NowPressed = 0
                                                    EndIf
                                                  Else
                                                  NowPressed = 0
                                                  EndIf
        
                                                Delay(50)
                                                Skipper = (Skipper + 1) % 4
                                                
                                                CompilerIf #AnimPlugin
                                                  If Skipper = 1
                                                    AnimateFullWin(1)
                                                    Else
                                                    AnimateFullWin(0)
                                                    EndIf
                                                  CompilerElse
                                                  AnimateFullWin()
                                                  If Skipper = 1
                                                    xCurrentFrame = xCurrentFrame + Skipper
                                                    MaxInit + 1
                                                    If MaxInit > 100
                                                      MaxInit = 100
                                                      EndIf
                                                    EndIf
                                                  If xCurrentFrame = xFrameCount
                                                    xCurrentFrame = 0
                                                    EndIf
                                                  CompilerEndIf

                                                If PeekI(?hThreadRes)
                                                  EnterCriticalSection_(?CritSection)
                                                  xLong6 = PeekI(?hThreadRes)
                                                  If xLong6
                                                    If PeekI(?hThreadLSD)
                                                      LeaveCriticalSection_(?CritSection)
                                                      Else
                                                      PokeI(?hThreadRes, 0)
                                                      LeaveCriticalSection_(?CritSection)
                                                      ProcessMenu(xLong6)
                                                      EndIf
                                                    Else
                                                    LeaveCriticalSection_(?CritSection)
                                                    EndIf
                                                  EndIf


                                                xLong6 = GetTickCount_() & $2000
                                                If Not xLong6 = LstTrayTimer Or HasIcon = 0
                                                  TrayIconChanged()
                                                  EndIf
                                                ForEver
    
    
                                              If RenderedTrayIcon
                                                DestroyIcon_(RenderedTrayIcon)
                                                EndIf


    
        CompilerIf #FixedUse
                                              ;If hRegion: DeleteObject_(hRegion): EndIf
                                              TerminateSelf()
                                              EndIf
        CompilerEndIf
                    EndIf
                  EndIf
                EndIf
              DestroyIcon_(OrgTrayIcon)
              EndIf
            EndIf
          EndIf
        EndIf
      SelectObject_(hDCTemp, hLSBmpOld)
      EndIf
    DeleteObject_(hIS\hbmMask)
    EndIf
  DeleteObject_(hIS\hbmColor)
  EndIf


                                                  SelectObject_(hDCTemp, hLSBmpOld)
                                                  EndIf
    
                                                DeleteDC_(hDCTemp)
                                                ;hDCTemp = 0
                                                EndIf
                                              EndIf
    
    
    
    
    
                                                ;Wend
                                          ;    KillTimer_(xMainHWnd, 1)
                                          ;    EndIf
                                          ;  KillTimer_(xMainHWnd, 0)
                                          ;  EndIf
                                      ;    EndIf
                                      ;  DestroyWindow_(hCloseWin)
                                      ;  If hCloseIcon
                                      ;    DestroyIcon_(hCloseIcon)
                                      ;    EndIf
                                      ;  EndIf
        CompilerIf #FixedUse
        CompilerElse
    ;                                  EndIf
        CompilerEndIf
                                    DeleteTextObject(*hBitmapGen)
CompilerIf #FullBMPRes
CompilerElse
                                    ElseIf xLong5
                                    DestroyIcon_(xLong5)
CompilerEndIf
                                    EndIf
                                  ;If TNotIcon\hWnd
                                  If HasIcon And SSPreview = 0 And SSAutoQuit = 0
                                    Shell_NotifyIcon_(#NIM_DELETE, @TNotIcon)
                                    EndIf
                                  ;  EndIf
                                  ;EndIf
CompilerIf #WarnMsg And #NoWarnOrQuitHack = 0
                                EndIf
CompilerEndIf
                              DestroyMenu_(xMenu)
                              DestroyMenu_(xPopupMenu)
                              Else
                              DestroyMenu_(xMenu)
                              EndIf
                            EndIf
                          RecStop()
                          EndIf
                        UnmapViewOfFile_(hMapFileViewWA)
                        EndIf
                      CloseHandle_(hMapFileWA)
                      EndIf
                    UnmapViewOfFile_(hMapFileViewQP)
                    EndIf
                  CloseHandle_(hMapFileQP)
                  EndIf
FreeMemory(MemTxtTemp)
EndIf
CompilerIf #LyricSupport
FreeMemory(MemTxtOldCalaymX)
EndIf
CompilerEndIf
                FreeMemory(MemTxtOld)
                EndIf
              DeleteObject_(hFontLarge)
              EndIf
            DeleteObject_(hFontTitle)
            EndIf
          If hIconQP
            DestroyIcon_(hIconQP)
            EndIf
          If hIconWA
            DestroyIcon_(hIconWA)
            EndIf
          If hIconAP
            DestroyIcon_(hIconAP)
            EndIf
          If hIconFO
            DestroyIcon_(hIconFO)
            EndIf
          CompilerIf #SilvesterSupport
            If hIconSS
              DestroyIcon_(hIconSS)
              EndIf
            CompilerEndIf
          ;DestroyIcon_(OrgTrayIcon)
          ;EndIf
        DestroyWindow_(xMainHWnd)
        ;EndIf
CompilerIf #FixedUse = 1
  CompilerElse
      If *hBitmapNxt
        DeleteTextObject(*hBitmapNxt)
        EndIf
CompilerEndIf
      If *hBitmapTxt
        DeleteTextObject(*hBitmapTxt)
        EndIf
      ;DestroyCursor_(hCursor)
      EndIf





;If hBrush_Green
  If Not hBrush_Red = hBrush_Green
    DeleteObject_(hBrush_Red)
    EndIf
  If Not hBrush_Yellow = hBrush_Green
    DeleteObject_(hBrush_Yellow)
    EndIf
  DeleteObject_(hBrush_Green)
  EndIf




If hBrush_SPosC
  DeleteObject_(hBrush_SPosT)
  DeleteObject_(hBrush_SPosC)
  EndIf

    ;CompilerIf #FixedUse
      DeleteObject_(hBrush)
    ;  CompilerEndIf
    EndIf
  ;LibBuild_Close()
  ;EndIf
  
  UnregisterClass_(#SpecialWindowClassName, hInstance)
  EndIf

DataSection
  hThreadLSD:
    Data.i 0
  hThreadRes:
    Data.i 0
;  CritSection: ;24 (dec)
;! CritSection: ;24 (dec)
;!   DD 0, 0, 0, 0, 0, 0


CompilerIf #AnimPlugin
CompilerElse
  FramesStart:
    IncludeBinary #AnimFile
  FramesEnd:
CompilerEndIf


  EndDataSection

Procedure DrawBmpCalcTextSizeEx(*xType1.TextBmpType, DCToUse.i)
  Define.RECT xType2
  If *xType1\Text2W
    CompilerIf #BlackenTextBack
      xType2\Left = xTxtLastLeft + *xType1\Text2X - 1
      xType2\bottom = xTxtLastTop + 44
      xType2\top = xType2\Bottom - 3
      xType2\Right = xTxtLastLeft + *xType1\Text2X + *xType1\Text2W + 1
      FillRect_(DCToUse, @xType2, hBrush)
      xType2\Left + 1
      xType2\bottom - 1
      xType2\top + 1
      CompilerElse
      xType2\Left = xTxtLastLeft + *xType1\Text2X
      xType2\bottom = xTxtLastTop + 43
      xType2\top = xType2\Bottom - 1
      CompilerEndIf
    
    xType2\Right = xType2\Left + MulDiv_(*xType1\ProgCur, *xType1\Text2W, *xType1\ProgTot)
    FillRect_(DCToUse, @xType2, hBrush_SPosC)
    xType2\left = xType2\right
    xType2\right = xTxtLastLeft + *xType1\Text2X + *xType1\Text2W
    FillRect_(DCToUse, @xType2, hBrush_SPosT)
    EndIf
  EndProcedure

Macro DrawBmpCalcTextSize(xType1, DCToUse, xLeft, xTop)
  xTxtLastLeft = xLeft
  xTxtLastTop = xTop
  DrawBmpCalcTextSizeEx(xType1, DCToUse)
  EndMacro

Macro TextOutWX(hDCTemp, Left, Top, ptrText, LenText)
  CompilerIf #BlackenTextBack
    CompilerIf #FixedUse
      SetTextColor_(hDCTemp, #FixedUseBkColor)
      CompilerElseIf #PSFMode
        hBrush = CreateSolidBrush_(#PSFColor)
        CompilerElse
        SetTextColor_(hDCTemp, 0)
        CompilerEndIf
    TextOutW(hDCTemp, Left-1, Top, ptrText, LenText)
    TextOutW(hDCTemp, Left+1, Top, ptrText, LenText)
    TextOutW(hDCTemp, Left, Top-1, ptrText, LenText)
    TextOutW(hDCTemp, Left, Top+1, ptrText, LenText)
    CompilerIf #FixedUse
      SetTextColor_(hDCTemp, #FixedUseFrColor)
      CompilerElseIf #PSFMode
      hBrush = CreateSolidBrush_(#PSFColorFont)
      CompilerElse
      SetTextColor_(hDCTemp, 0)
      CompilerEndIf
    SetTextColor_(hDCTemp, $ffffff)
    CompilerEndIf
  TextOutW(hDCTemp, Left, Top, ptrText, LenText)
  EndMacro

Macro TextOutAX(hDCTemp, Left, Top, ptrText, LenText)
  CompilerIf #BlackenTextBack
    CompilerIf #FixedUse
      SetTextColor_(hDCTemp, #FixedUseBkColor)
      CompilerElseIf #PSFMode
      hBrush = CreateSolidBrush_(#PSFColor)
      CompilerElse
      SetTextColor_(hDCTemp, 0)
      CompilerEndIf
    TextOut_(hDCTemp, Left-1, Top, ptrText, LenText)
    TextOut_(hDCTemp, Left+1, Top, ptrText, LenText)
    TextOut_(hDCTemp, Left, Top-1, ptrText, LenText)
    TextOut_(hDCTemp, Left, Top+1, ptrText, LenText)
    CompilerIf #FixedUse
      SetTextColor_(hDCTemp, #FixedUseFrColor)
      CompilerElseIf #PSFMode
      hBrush = CreateSolidBrush_(#PSFColorFont)
      CompilerElse
      SetTextColor_(hDCTemp, $ffffff)
      CompilerEndIf
    CompilerEndIf
  TextOut_(hDCTemp, Left, Top, ptrText, LenText)
  EndMacro

CompilerIf #RenderMainInfoMySelf = 3
  Procedure DrawBmp(*xType1.TextBmpType, xLeft.l, xTop.l)
    Define.i hFontOld = SelectObject_(hDCTemp3, hFontLarge)
    If hFontOld
      DrawIconEx_(hDCTemp3, xLeft, xTop + *xType1\hIconY, *xType1\hIcon, 48, 48, 0, 0, #DI_NORMAL)
      If SSPreview = 0
        TextOutWX(hDCTemp3, xLeft + *xType1\Text1X, xTop + *xType1\Text1Y, *xType1\Text1, *xType1\Text1L)
        SelectObject_(hDCTemp3, hFontTitle)
        TextOutAX(hDCTemp3, xLeft + *xType1\Text2X, xTop + *xType1\Text2Y, *xType1\Text2, *xType1\Text2L)
        EndIf
      DrawBmpCalcTextSize(*xType1, hDCTemp3, xLeft, xTop)
      SelectObject_(hDCTemp3, hFontOld)
      EndIf
    EndProcedure
  CompilerElseIf #RenderMainInfoMySelf
  Procedure DrawBmp(*xType1.TextBmpType, xLeft.l, xTop.l)
    Define.i hFontOld = SelectObject_(hDCTemp, hFontLarge)
    If hFontOld
      DrawIconEx_(hDCTemp, xLeft, xTop + *xType1\hIconY, *xType1\hIcon, 48, 48, 0, 0, #DI_NORMAL)
      If SSPreview = 0
        TextOutWX(hDCTemp, xLeft + *xType1\Text1X, xTop + *xType1\Text1Y, *xType1\Text1, *xType1\Text1L)
        SelectObject_(hDCTemp, hFontTitle)
        TextOutAX(hDCTemp, xLeft + *xType1\Text2X, xTop + *xType1\Text2Y, *xType1\Text2, *xType1\Text2L)
        EndIf
      DrawBmpCalcTextSize(*xType1, hDCTemp, xLeft, xTop)
      SelectObject_(hDCTemp, hFontOld)
      EndIf
    EndProcedure
  CompilerElse
  Procedure DrawBmp(*xType1.TextBmpType, xLeft.l, xTop.l)
  ;Debug "Icon: " + Str(*xType1\hIcon)
;Debug "RedrawPos"
    Define.i hFontOld = SelectObject_(xMainDC, hFontLarge)
    If hFontOld
     CompilerIf #FixedUse
      SetBkColor_(xMainDC, #FixedUseBkColor)
      SetBkMode_(xMainDC, 1)
      CompilerIf Not #BlackenTextBack
        SetTextColor_(xMainDC, #FixedUseFrColor)
        CompilerEndIf
      CompilerElse
      CompilerIf #PSFMode
        SetBkColor_(xMainDC, #PSFColor)
        CompilerIf Not #BlackenTextBack
          SetTextColor_(xMainDC, #PSFColorFont)
          CompilerEndIf 
        CompilerElse
        SetBkColor_(xMainDC, 0)
        CompilerIf Not #BlackenTextBack
          SetTextColor_(xMainDC, $ffffff)
          CompilerEndIf
        CompilerEndIf
      CompilerEndIf
  
  ;Debug "Pos: " +Str(xLeft) + ", " + Str(xTop)
  ;Debug "Icon on: 0, " + Str(*xType1\hIconY) + " (" + Str(*xType1\hIcon) + ")"
      DrawIconEx_(xMainDC, xLeft, xTop + *xType1\hIconY, *xType1\hIcon, 48, 48, 0, 0, #DI_NORMAL)
      If SSPreview = 0
        TextOutWX(xMainDC, xLeft + *xType1\Text1X, xTop + *xType1\Text1Y, *xType1\Text1, *xType1\Text1L)
        SelectObject_(xMainDC, hFontTitle)
        TextOutAX(xMainDC, xLeft + *xType1\Text2X, xTop + *xType1\Text2Y, *xType1\Text2, *xType1\Text2L)
        EndIf
      DrawBmpCalcTextSize(*xType1, xMainDC, xLeft, xTop)
      SelectObject_(xMainDC, hFontOld)
      EndIf
    EndProcedure
  CompilerEndIf

Macro DrawBmpRe()
  DrawBmpEx(*hBitmapTxt, xTxtLastLeft, xTxtLastTop)
  EndMacro


; 1 = sylvester counter
; 10 = calaym
; 11 = appollo
; 12 = winamp

;Procedure.i UpdateBmpPos(*xType1.TextBmpType, ProgCur.i)
;  *xType1\ProgCur = ProgCur
;  EndProcedure

Procedure.i TxtToBmp(IconHandle.i, LenLargeTitle.l, Head.s, xMode.i, ProgCur.i, ProgTot.i, LyrMinWidthPX.i)
  Define.i hDC
  Define.RECT xType1
  Define.POINT xType2
  Define.TextBmpType xType3
  Define.i xResult
  Define.i xLong1
  
  xLong1 = GetDC_(xMainHWnd)
  If xLong1
    hDC = CreateCompatibleDC_(xLong1)
    ReleaseDC_(xMainHWnd, xLong1)
    If hDC
      xType3\Text1 = AllocateMemory(LenLargeTitle * 2)
      If xType3\Text1
        xType3\Text2 = AllocateMemory(Len(Head))
        If xType3\Text2
          RtlMoveMemory_(xType3\Text1, MemTxtOld, LenLargeTitle * 2)
          RtlMoveMemory_(xType3\Text2, @Head, Len(Head))
          xType3\Text1L = LenLargeTitle
          xType3\Text2L = Len(Head)
          xResult = AllocateMemory(SizeOf(TextBmpType))
          If xResult

            Define.l hFontOld = SelectObject_(hDC, hFontTitle)
            GetTextExtentPoint32_(hDC, Head, Len(Head), @xType2)
            SelectObject_(hDC, hFontLarge)
            GetTextExtentPoint32W(hDC, MemTxtOld, LenLargeTitle, @xType1\Right)
;Debug Str(xType1\right) + " <> " + Str(LyrMinWidthPX)
            If xType1\right < LyrMinWidthPX
              xType1\right = LyrMinWidthPX
              EndIf
            If ProgTot And hBrush_SPosT
              xType3\Text2W = xType1\Right + 1
              xType3\ProgCur = ProgCur
              xType3\ProgTot = ProgTot
              EndIf

            CompilerIf #HAlign = 1
              If xType1\Right < xType2\X
                xType1\Right = xType2\X
                EndIf
              xType1\Right + 56
              CompilerIf #FixedUse = 1
                CompilerElse
                CompilerEndIf
              CompilerElse
              xType2\Y = xType1\Bottom
              
              If xType1\Right < xType2\X
                xType1\Bottom = xType2\X + 56
                Else
                xType1\Bottom = xType1\Right + 56
                EndIf
              xType1\Right = xType1\Bottom
              CompilerIf #FixedUse = 1
                If xType1\Bottom > InfoHeightMax
                  xType1\Bottom = InfoHeightMax
                  EndIf
                CompilerElse
                If xType1\Bottom > FullWindowH + 56
                  xType1\Bottom = FullWindowH + 56
                  EndIf
                CompilerEndIf
              CompilerEndIf
      
            xType3\hIcon = IconHandle
            CompilerIf #HAlign = 1
              xType1\Bottom = 48
              xType1\Left = 56
              CompilerElse
              xType1\Right = 48
              xType3\hIconY = xType1\Bottom - 48
              xType1\Bottom - 56
              CompilerEndIf
      
            CompilerIf #FixedUse
              CompilerIf #SmallerFonts
                CompilerIf #HAlign = 1
                  xType3\Text1X = 56
                  xType3\Text1Y = 17
                  CompilerElse
                  xType3\Text1X = 17
                  xType3\Text1Y = xType1\Bottom
                  CompilerEndIf
                CompilerElse
                CompilerIf #HAlign = 1
                  xType3\Text1X = 56
                  xType3\Text1Y = 14
                  CompilerElse
                  xType3\Text1X = 14
                  xType3\Text1Y = xType1\Bottom
                  CompilerEndIf
                CompilerEndIf
              CompilerElse
              CompilerIf #HAlign = 1
                xType3\Text1X = 56
                xType3\Text1Y = 14
                CompilerElse
                xType3\Text1X = 14
                xType3\Text1Y = xType1\Bottom
                CompilerEndIf
              CompilerEndIf
            CompilerIf #FixedUse
              CompilerIf #SmallerFonts
                CompilerIf #HAlign = 1
                  xType3\Text2X = 56
                  xType3\Text2Y = 7
                  CompilerElse
                  xType3\Text2X = 7
                  xType3\Text2Y = xType1\Bottom
                  CompilerEndIf
                CompilerElse
                CompilerIf #HAlign = 1
                  xType3\Text2X = 56
                  xType3\Text2Y = 4
                  CompilerElse
                  xType3\Text2X = 4
                  xType3\Text2Y = xType1\Bottom
                  CompilerEndIf
                CompilerEndIf
              CompilerElse
              CompilerIf #HAlign = 1
                xType3\Text2X = 56
                xType3\Text2Y = 4
                CompilerElse
                xType3\Text2X = 4
                xType3\Text2Y = xType1\Bottom
                CompilerEndIf
              CompilerEndIf
      
            CompilerIf #FixedUse = 1
              CompilerIf #HAlign = 1
                InfoWidth = xType1\Right
                CompilerElse
                InfoWidth = xType1\Bottom + 56
                CompilerEndIf
              CompilerEndIf
;Debug "ReturnSize: " + Str(xType1\Right) + ", " + Str(xType1\Bottom)
            CompilerIf #HAlign = 1
              PicSizeX = xType1\Right
              CompilerElse
              PicSizeX = xType1\Bottom + 56
              CompilerEndIf
            xType3\xMode = xMode
            If ProgTot And hBrush_SPosT
              xType3\Text1Y - 3
              xType3\Text2Y - 3
              EndIf
            RtlMoveMemory_(xResult, xType3, SizeOf(TextBmpType))
            Goto Success
            EndIf
          FreeMemory(xType3\Text2)
          EndIf
        FreeMemory(xType3\Text1)
        EndIf
Success:
      SelectObject_(hDC, hFontOld)
      DeleteDC_(hDC)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

CompilerIf #FixedUse = 1
  CompilerElse
  Procedure NowResize()
    ;Define.NONCLIENTMETRICS xType1
    ;#RePosFlag = #SWP_NOACTIVATE | #SWP_NOOWNERZORDER | #SWP_NOSIZE | #SWP_NOZORDER
  
    ;If gImage
      ;ShowWindow_(gImage, 0)
      CompilerIf #RenderSelf = 2
        CompilerIf #AnimPlugin = 1
          ExcludeTop = #BorderForImage
          CompilerElse
          ExcludeTop = 4 * FullWindow_H
          ExcludeBottom = ExcludeTop + #PicSizeYOX ;#PicSizeHET
          CompilerEndIf
        CompilerEndIf
      CompilerIf #AnimPlugin = 1
        ;SetWindowPos_(gImage, 0, (LastDeskPos\Right - LastDeskPos\Left - PicSizeX) / 2, #BorderForImage, 0, 0, #RePosFlag)
CompilerIf #HAlign = 1
        If LastDeskPos\Right < PicSizeXC
          InfoLeft = -56
CompilerElse
        If LastDeskPos\Bottom < PicSizeXC
          InfoTop = LastDeskPos\Bottom + 56 - PicSizeXC
CompilerEndIf
CompilerIf #FixedUse
CompilerElse
          CompilerIf #HAlign = 1
            InfoTop = #BorderForImage
            CompilerElse
            InfoLeft = #BorderForImage
            CompilerEndIf
CompilerEndIf
          Else
          CompilerIf #HAlign = 1
            InfoLeft = (LastDeskPos\Right - PicSizeXC) / 2
            CompilerElse
            InfoTop = (LastDeskPos\Bottom - PicSizeXC) / 2
            CompilerEndIf
CompilerIf #FixedUse
CompilerElse
          CompilerIf #HAlign = 1
            InfoTop = #BorderForImage
            CompilerElse
            InfoLeft = #BorderForImage
            CompilerEndIf
CompilerEndIf
          EndIf
        CompilerElse
        ;SetWindowPos_(gImage, 0, (LastDeskPos\Right - LastDeskPos\Left - PicSizeXC) / 2, 4 * FullWindow_H + #BorderForImage, 0, 0, #RePosFlag)
        CompilerIf #HAlign = 1
          If LastDeskPos\Right < PicSizeXC
            InfoLeft = -56
            Else
            InfoLeft = (LastDeskPos\Right - PicSizeXC) / 2
            EndIf
          InfoTop = 4 * FullWindow_H + #BorderForImage
          CompilerElse
          If LastDeskPos\Bottom < PicSizeXC
            InfoTop = LastDeskPos\Bottom + 56
            Else
            InfoTop = (LastDeskPos\Bottom - PicSizeXC) / 2
            EndIf
          CompilerIf #HAlign = 2
            ;InfoLeft = #BorderForImage
            InfoLeft = (LastDeskPos\Right - 48 - RealRenderWidth) / 2
            CompilerElse
            ;InfoLeft = LastDeskPos\Right - 48 + #BorderForImage
            InfoLeft = RealRenderWidth + (LastDeskPos\Right - 48 - RealRenderWidth) / 2
            CompilerEndIf
          CompilerEndIf
        CompilerEndIf
    ;  EndIf
;Debug InfoTop
;Debug "RealRenderWidth: " + Str(RealRenderWidth)
;Debug "InfoLeft: " + Str(InfoLeft)
    EndProcedure
  CompilerEndIf

Procedure TxtFileReader_Close(*hTxtFileIn.TxtFileReadStruct)
  If *hTxtFileIn
    If *hTxtFileIn\hMem
      FreeMemory(*hTxtFileIn\hMem)
      EndIf
    FreeMemory(*hTxtFileIn)
    EndIf
  EndProcedure

#FILE_READ      = $80000000
#CP_UTF8 = 65001

Procedure.i TxtFileReader_OpenEx(*FilenameW, *InOutEncoding, *PureTextSize)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2
  Define.i hFile
  Define.i InOutEncoding
  Define.i PureTextSize
  Define.i xBoolFail
  Define.i xChar1
  Define.s Filename

  xResult = -1
  hFile = CreateFileW(*FilenameW, #FILE_READ, $1, 0, #OPEN_EXISTING, $20, 0)
  If hFile = -1
    Filename = PeekS(*FilenameW, -1, #PB_Unicode)
    hFile = CreateFile_(@Filename, #FILE_READ, $1, 0, #OPEN_EXISTING, $20, 0)
    EndIf
  If Not hFile = -1
    PureTextSize = GetFileSize_(hFile, xLong1)
    If xLong1 = 0 And PureTextSize < $4000000
      InOutEncoding = PeekI(*InOutEncoding)
      If ReadFile_(hFile, @xLong1, 3, @xLong2, 0)
        If (xLong1 & $FFFF) = $FEFF
          If Not (PureTextSize & 1)
            PureTextSize - 2
            InOutEncoding = #CP_WINUNICODE
            If (SetFilePointer_(hFile, 2, 0, 0) & $ffffffff) = $ffffffff
              xBoolFail = #True
              Else
              xResult = hFile
              EndIf
            EndIf
          ElseIf (xLong1 & $FFFFFF) = $BFBBEF
          PureTextSize = PureTextSize - 3
          InOutEncoding = #CP_UTF8
          xResult = hFile
          EndIf
        EndIf
      If xResult = -1
        If Not xBoolFail
          If (PureTextSize & 1) = 0 Or InOutEncoding <> #CP_WINUNICODE
            If Not ((SetFilePointer_(hFile, 0, 0, 0) & $ffffffff) = $ffffffff)
              xResult = hFile
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
    If xResult = -1
      CloseHandle_(hFile)
      Else
      PokeI(*InOutEncoding, InOutEncoding)
      PokeI(*PureTextSize, PureTextSize)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i TxtFileReader_FromFile(*FilenameW, DefaultEncoding = #CP_ACP)
  Define.i xResult
  Define.i hFile
  Define.i xSize
  Define.i xLong1
  Define.i xLong2
  Define *hMemTmp
  Define *xType1.TxtFileReadStruct

  hFile = TxtFileReader_OpenEx(*FilenameW, @DefaultEncoding, @xSize)
  If Not hFile = -1
    *xType1 = AllocateMemory(SizeOf(TxtFileReadStruct))
    If *xType1
      If xSize = 0
        xResult = *xType1
        Else
        If DefaultEncoding = #CP_WINUNICODE
          *xType1\hMem = AllocateMemory(xSize + 6)
          If *xType1\hMem
            If ReadFile_(hFile, *xType1\hMem, xSize, @xLong1, 0)
              If xSize = xLong1
                xResult = *xType1
                EndIf
              EndIf
            EndIf
          Else
          *hMemTmp = AllocateMemory(xSize + 1)
          If *hMemTmp
            If ReadFile_(hFile, *hMemTmp, xSize, @xLong1, 0)
              If xSize = xLong1
                xLong1 = MultiByteToWideChar_(DefaultEncoding, 0, *hMemTmp, xSize, 0, 0)
                If xLong1
                  *xType1\hMem = AllocateMemory((xLong1 << 1) + 8)
                  If *xType1\hMem
                    xLong2 = MultiByteToWideChar_(DefaultEncoding, 0, *hMemTmp, xSize, *xType1\hMem, xLong1)
                    If xLong1 = xLong2
                      xSize = xLong1 << 1
                      xResult = *xType1
                      EndIf
                    EndIf
                  EndIf
                EndIf
              EndIf
            FreeMemory(*hMemTmp)
            EndIf
          EndIf
        If xResult
          *xType1\Encoding = DefaultEncoding
          *xType1\hMemPos = *xType1\hMem
          *xType1\hMemEnd = *xType1\hMem + xSize
          PokeW(*xType1\hMemEnd+0, 13)
          PokeW(*xType1\hMemEnd+2, 10)
          PokeW(*xType1\hMemEnd+4,  0)
          xResult = *xType1
          ElseIf *xType1\hMem
          FreeMemory(*xType1\hMem)
          EndIf
        EndIf
      If Not xResult
        FreeMemory(*xType1)
        EndIf
      EndIf
    CloseHandle_(hFile)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i TxtFileReader_LBParser(*ptrStringW, *ptrLenOut)
  Define.i xResult

  EnableASM
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      MOV rax, *ptrStringW
      PUSH rsi
      MOV rsi, rax
      !xor rax, rax
      !xor rcx, rcx
  
      CLD
;Search for CR
!TxtFileReader_LBParser_Loop1:
      LODSW
      !or ax, ax
      JZ TxtFileReader_LBParser_EndOfString
      CMP ax, $0d
      JE TxtFileReader_LBParser_FoundCR
      CMP ax, $0a
      JNE TxtFileReader_LBParser_Loop1

; LF   / 0A   / 10
      MOV rcx, 2
      SUB rsi, rcx
      JMP TxtFileReader_LBParser_Found

!TxtFileReader_LBParser_FoundCR:
; CR   / 0D   / 13
; CRLF / 0D0A / 1310
; Test if LF
      LODSW
      CMP ax, $0a
      JE TxtFileReader_LBParser_FoundCRFL

; CR   / 0D   / 13
      MOV rcx, 2
      SUB rsi, 4
      JMP TxtFileReader_LBParser_Found

!TxtFileReader_LBParser_FoundCRFL:
; CRLF / 0D0A / 1310
      MOV rcx, 4
      SUB rsi, rcx

!TxtFileReader_LBParser_Found:
      MOV rax, rsi

!TxtFileReader_LBParser_EndOfString:
      POP rsi
    
      MOV xResult, rax
      MOV *ptrStringW, rcx
      PokeL(*ptrLenOut, *ptrStringW)
      CompilerElse
      MOV eax, *ptrStringW
      PUSH esi
      MOV esi, eax
      !xor eax, eax
      !xor ecx, ecx
  
      CLD
;Search for CR
!TxtFileReader_LBParser_Loop1:
      LODSW
      !or ax, ax
      JZ TxtFileReader_LBParser_EndOfString
      CMP ax, $0d
      JE TxtFileReader_LBParser_FoundCR
      CMP ax, $0a
      JNE TxtFileReader_LBParser_Loop1

; LF   / 0A   / 10
      MOV ecx, 2
      SUB esi, ecx
      JMP TxtFileReader_LBParser_Found

!TxtFileReader_LBParser_FoundCR:
; CR   / 0D   / 13
; CRLF / 0D0A / 1310
; Test if LF
      LODSW
      CMP ax, $0a
      JE TxtFileReader_LBParser_FoundCRFL

; CR   / 0D   / 13
      MOV ecx, 2
      SUB esi, 4
      JMP TxtFileReader_LBParser_Found

!TxtFileReader_LBParser_FoundCRFL:
; CRLF / 0D0A / 1310
      MOV ecx, 4
      SUB esi, ecx

!TxtFileReader_LBParser_Found:
      MOV eax, esi

!TxtFileReader_LBParser_EndOfString:
      POP esi
    
      MOV xResult, eax
      MOV *ptrStringW, ecx
      PokeL(*ptrLenOut, *ptrStringW)
      CompilerEndIf
    DisableASM
  ProcedureReturn xResult
  EndProcedure

;boolean -> ptrstr (ptrtemp?)
Procedure.i TxtFileReader_NextLine(*hTxtFileIn.TxtFileReadStruct)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2

  If *hTxtFileIn
    If *hTxtFileIn\hMem And Not *hTxtFileIn\hMemPos = *hTxtFileIn\hMemEnd
      *hTxtFileIn\LastPos = *hTxtFileIn\hMemPos
      xLong1 = TxtFileReader_LBParser(*hTxtFileIn\hMemPos, @xLong2)
      If xLong1
        *hTxtFileIn\LastEnd = xLong1
        *hTxtFileIn\hMemPos = xLong1 + xLong2
        xResult = #True
        Else
        *hTxtFileIn\LastEnd = *hTxtFileIn\LastPos
        FreeMemory(*hTxtFileIn\hMem)
        *hTxtFileIn\hMem = 0
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i TxtFileReader_GetLineString(*hTxtFileIn.TxtFileReadStruct, *LenChars)
  Define.i xResult
  If *hTxtFileIn
    If *hTxtFileIn\LastPos And *hTxtFileIn\LastEnd
      If Not *hTxtFileIn\LastPos = *hTxtFileIn\LastEnd
        xResult = *hTxtFileIn\LastPos
        PokeI(*LenChars, (*hTxtFileIn\LastEnd - *hTxtFileIn\LastPos) >> 1)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure ClearLyrics()
  While LyricCount
    LyricCount - 1
    If LyricLines(LyricCount)
      FreeMemory(LyricLines(LyricCount))
      LyricLines(LyricCount) = 0
      EndIf
    Wend
  OldLyricLine = -1
  EndProcedure

Procedure.i ReadLyricFile(*PtrMemFN, MaxLen.i)
  Define.i LastDot
  Define.i hFile
  Define *Mem
  Define *Line
  Define.i xLenC
  Define.s xChar1
  Define.i LyrMinWidthPX
  Define.i hDC
  Define.i xLong1
  Define.l hFontOld
  Define.POINT xType1

  PokeW(*PtrMemFN + MaxLen << 1, 0)
  LastDot = *PtrMemFN
EnableASM
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    MOV rax, LastDot
    XOR rdx, rdx
    DEC rax
    DEC rax
!FLD_Loop:
    INC rax
    INC rax
    MOV cx, word [rax]
    OR cx, cx
    JZ FLD_Zero
    CMP cx, 46
    JNE FLD_Loop
    MOV rdx, rax
    JMP FLD_Loop
  
!FLD_Zero:
    MOV LastDot, rdx
    CompilerElse
    MOV eax, LastDot
    XOR edx, edx
    DEC eax
    DEC eax
!FLD_Loop:
    INC eax
    INC eax
    MOV cx, word [eax]
    OR cx, cx
    JZ FLD_Zero
    CMP cx, 46
    JNE FLD_Loop
    MOV edx, eax
    JMP FLD_Loop
  
!FLD_Zero:
    MOV LastDot, edx
    CompilerEndIf
  DisableASM

  ClearLyrics()
  If LastDot
    LastDot - *PtrMemFN + 2
    Debug LastDot
    *Mem = AllocateMemory(LastDot + 22)
    If *Mem
      PokeS(*Mem, "Lyrics\", 7, #PB_Unicode)
      RtlMoveMemory_(*Mem + 14, *PtrMemFN, LastDot)
      PokeS(*Mem + 14 + LastDot, "lrc", 3, #PB_Unicode)
      PokeW(*Mem + 14 + LastDot + 6, 0)
;Debug "LyricFile: " + PeekS(*Mem, -1, #PB_Unicode)
      hFile = TxtFileReader_FromFile(*Mem, #CP_UTF8)
      If hFile
        xLong1 = GetDC_(xMainHWnd)
        If xLong1
          hDC = CreateCompatibleDC_(xLong1)
          ReleaseDC_(xMainHWnd, xLong1)
          If hDC
            hFontOld = SelectObject_(hDC, hFontLarge)
            If hFontOld
              While TxtFileReader_NextLine(hFile)
                *Line = TxtFileReader_GetLineString(hFile, @xLenC)
                If *Line And xLenC > 9 And xLenC < $158 ;  - 20 later, so already below
                  If PeekW(*Line) = 91 And PeekW(*Line + 6) = 58 And PeekW(*Line + 12) = 46 And PeekW(*Line + 18) = 93
                    xChar1 = PeekS(*Line + 2, 8, #PB_Unicode)
                    LyricTimes(LyricCount) = Val(Left(xChar1, 2)) * 60000 + Val(Mid(xChar1, 4, 2)) * 1000 + Val(Mid(xChar1, 7, 2)) * 10
                    xLenC - 10
                    If xLenC
                      LyricLines(LyricCount) = AllocateMemory((xLenC + 2) << 1)
                      If LyricLines(LyricCount)
                        PokeW(LyricLines(LyricCount), xLenC)
                        RtlMoveMemory_(LyricLines(LyricCount) + 2, *Line + 20, xLenC << 1)
                        ;PokeW(LyricLines(LyricCount) + (xLenC + 1) << 1, 0)
                        GetTextExtentPoint32W(hDC, *Line + 20, xLenC, @xType1)
                        ;Debug xType1\x
                        If xType1\x > LyrMinWidthPX
                          LyrMinWidthPX = xType1\x
                          EndIf
                        ;Debug Str(LyricTimes(LyricCount)) + " (" + Str(LyricCount) + "): " + PeekS(LyricLines(LyricCount) + 2, PeekW(LyricLines(LyricCount)), #PB_Unicode)
                        EndIf
                      EndIf
                    LyricCount + 1
                    EndIf
                  EndIf
                Wend
              SelectObject_(hDC, hFontOld)
              EndIf
            DeleteDC_(hDC)
            EndIf
          EndIf
        TxtFileReader_Close(hFile)
        EndIf
      FreeMemory(*Mem)
      EndIf
    EndIf
  Debug "Final: " + Str(LyrMinWidthPX)
  ProcedureReturn LyrMinWidthPX
  EndProcedure

Procedure CalcAndDrawInfoPos()
  Define.RECT xType1
CompilerIf #SpectrumRedrawInfo Or #HideText
CompilerElse
;Debug Str(GetTickCount_())
  CompilerIf #FixedUse = 1
    CompilerIf #HAlign = 1
      xType1\Left = InfoLeft + InfoWidth
      xType1\Top = InfoTop
      xType1\Right = InfoWidthMax ; InfoLeft + InfoWidthMax; - InfoWidth
      xType1\Bottom = InfoTop + 48
      CompilerElse
      xType1\Left = InfoLeft
      xType1\Top = InfoTop + InfoWidth
      xType1\Right = InfoLeft + 48; InfoLeft + InfoWidthMax; - InfoWidth
      xType1\Bottom = InfoTop + InfoWidthMax
      CompilerEndIf
    CompilerElse
    NowResize()
    CompilerIf #HAlign = 1
      xType1\Left = 0
      xType1\Top = InfoTop
      xType1\Right = FullWindowW
      xType1\Bottom = InfoTop + 48
      CompilerElse
      xType1\Left = InfoLeft
      xType1\Right = InfoLeft + 48
      xType1\Top = 0
      xType1\Bottom = FullWindowH
      CompilerEndIf
    CompilerEndIf

CompilerIf #RenderMainInfoMySelf Or #HideText
CompilerElse

  CompilerIf #OnPicRender
    CompilerIf #HideText
      CompilerElse
      Define.i Success
    
      If hBmp1
        If IsAlpha
          Success = BitBlt_(xMainDC, xType1\Left, xType1\Top, xType1\Right - xType1\Left, xType1\Bottom - xType1\Top, hDCTemp2, xType1\Left, xType1\Top, #SRCCOPY)
          EndIf
        EndIf
      If Success = 0
        FillRect_(xMainDC, @xType1, hBrush)
        EndIf
      CompilerEndIf
    CompilerElse
    FillRect_(xMainDC, @xType1, hBrush)
    CompilerEndIf
CompilerEndIf
CompilerEndIf

CompilerIf #HideText
CompilerElse

  CompilerIf #FixedUse = 1
    xType1\Left = InfoLeft
    xType1\Top = InfoTop
    CompilerIf #HAlign = 1
      xType1\Right = InfoWidthGen
      xType1\Bottom = 48
;          BitBlt_(xMainDC, InfoLeft, InfoTop, InfoWidthGen, 48, hDCTemp, 0, 0, #SRCCOPY)
      CompilerElse
      xType1\Right = 48
      xType1\Bottom = InfoWidthGen
      ;BitBlt_(xMainDC, InfoLeft, InfoTop, 48, InfoWidthGen, hDCTemp, 0, 0, #SRCCOPY)
      CompilerEndIf
    CompilerElse
    CompilerIf #HAlign = 1
      xType1\Left = InfoIs
      xType1\Top = InfoTop
      xType1\Right = PicSizeXC
      xType1\Bottom = 48
;          BitBlt_(xMainDC, InfoIs, InfoTop, PicSizeXC, 48, hDCTemp, 0, 0, #SRCCOPY)
      CompilerElse
      xType1\Left = InfoLeft
      xType1\Top = InfoIs
      xType1\Right = 48
      xType1\Bottom = PicSizeXC
;          BitBlt_(xMainDC, InfoLeft, InfoIs, 48, PicSizeXC, hDCTemp, 0, 0, #SRCCOPY)
      CompilerEndIf
    CompilerEndIf
;  CompilerIf #OnPicRender
;    If Success
;      Success = 0
;CompilerIf #HAlign = 1
;      Success = BitBlt_(xMainDC, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, hDCTemp2, xType1\Left, 0, #SRCCOPY)
;CompilerElse
;      Success = BitBlt_(xMainDC, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, hDCTemp2, 0, xType1\Top, #SRCCOPY)
;CompilerEndIf
;      EndIf
;    If Success = 0
;      BitBlt_(xMainDC, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, hDCTemp, 0, 0, #SRCCOPY)
;      EndIf
;    CompilerElse
;    BitBlt_(xMainDC, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, hDCTemp, 0, 0, #SRCCOPY)
;    CompilerEndIf
  CompilerIf #RenderMainInfoMySelf
;Debug "RedrawPosEx: " + Str(xType1\Left)
    CompilerIf #HAlign = 1
      RenderMainInfoMySelf_RPLeft = xType1\Left
      CompilerElse
      RenderMainInfoMySelf_RPTop = xType1\Top
      CompilerEndIf
    CompilerElse
;Debug "RedrawPosEx: " + Str(xType1\Left)
    If *hBitmapTxt
      DrawBmp(*hBitmapTxt, xType1\Left, xType1\Top)
      Else
      DrawBmp(*hBitmapGen, xType1\Left, xType1\Top)
      EndIf
    CompilerEndIf
CompilerEndIf
  EndProcedure

Procedure.l FoobarFinder(hWnd, lParam)
  If SSPreview
    ProcedureReturn
    EndIf
  CompilerIf #NoPlayerDet
    ProcedureReturn
    CompilerEndIf

;Debug "FF1: " + Str(hWnd) + ", " + Str(GetClassName_(hWnd, MemTxtTemp, 40))
  If GetClassName_(hWnd, MemTxtTemp, 40) = 38
;Debug "FF2: " + PeekS(MemTxtTemp, 38)
    Select PeekS(MemTxtTemp, 38)
      Case "{DA7CD0DE-1602-45e6-89A1-C2CA151E008E}", "{97E27FAA-C0B3-4b8e-A693-ED7881E99FC1}"
        If GetWindow_(hWnd, #GW_CHILD)
  ;Debug "FF3: Childed!"
          lParam = SendMessage_(hWnd, #WM_GETTEXT, $150, MemTxtTemp)
          If lParam > 12
            If LCase(PeekS(MemTxtTemp, 12)) = "foobar2000 v"
              ProcedureReturn #True
              EndIf
            EndIf
          hWinFoobar = hWnd
          ProcedureReturn 0
          EndIf
      EndSelect
    EndIf
  ProcedureReturn #True
  EndProcedure

Procedure.l FromWindow(hWin.l, hIcon.l, FilterMode.l, *Success)
  Define.i xLong1 = hWin
  ;Define.s StrNow = NowPlay

  If SSPreview
    ProcedureReturn
    EndIf
  CompilerIf #NoPlayerDet
    ProcedureReturn
    CompilerEndIf

  If xLong1
;Debug "FW: Found"
    Define.i xSize
    Define.s xChar1
    
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      xSize = SendMessageW(xLong1, #WM_GETTEXT, $150, MemTxtTemp)
      If xSize And xSize < $148
;Debug "FW: SizeOKW"
        xChar1 = PeekS(MemTxtTemp, xSize, #PB_Unicode)
        ;Goto SharedProcess
CompilerElse
    If IsUnicode
      xSize = SendMessageW(xLong1, #WM_GETTEXT, $150, MemTxtTemp)
      If xSize And xSize < $148
;Debug "FW: SizeOKW"
        xChar1 = PeekS(MemTxtTemp, xSize, #PB_Unicode)
        Goto SharedProcess
        EndIf
      Else
      xSize = SendMessage_(xLong1, #WM_GETTEXT, $150, MemTxtTemp)
      If xSize And xSize < $148
;Debug "FW: SizeOKA"
        xChar1 = PeekS(MemTxtTemp, xSize)
;Debug "FW: String is " + xChar1
        PokeS(MemTxtTemp, xChar1, xSize, #PB_Unicode)
SharedProcess:
CompilerEndIf        
        PokeW(MemTxtTemp + xSize * 2, 0)
        Define.l xLong2
        If FilterMode = 1
;Debug "FW: Filter"
          If Right(xChar1, 1) = "]"
            xLong1 = 0
            Repeat
              xLong2 = FindString(xChar1, "[", xLong1 + 1)
              If xLong2 = 0: Break: EndIf
              xLong1 = xLong2
              ForEver
            If xLong1
;Debug "FW: Filter: #" + LCase(Mid(xChar1, xLong1 + 1, Len(xChar1) - xLong1 - 1)) + "#"
              Define.s xChar2 = LCase(Mid(xChar1, xLong1 + 1, Len(xChar1) - xLong1 - 1))
              Select xChar2
                Case "paused", "stopped"
                  ProcedureReturn 0
                Default
                  If hIcon = hIconFO
                    If Len(xChar2) > 12
                      If Left(xChar2, 12) = "foobar2000 v"
                        xChar1 = RTrim(Left(xChar1, xLong1 - 1))
                        ;Debug "Stripped to: " + xChar1 + " / " + Str(Len(xChar1))
                        xSize = Len(xChar1)
                        PokeW(MemTxtTemp + xSize * 2, 0)
                        ;Goto StrippedFO
                        EndIf
                      EndIf
                    EndIf
                EndSelect
              EndIf
            EndIf
          If hIcon = hIconWA
            xLong1 = FindWindow_("Apollo - Main Window", 0)
            If xLong1
              If GetWindowThreadProcessId_(hWin, 0) = GetWindowThreadProcessId_(xLong1, 0)
                ;StrNow = NowTrack
                hIcon = hIconAP
                EndIf
              Else
              If Left(xChar1, 7) = "Winamp " And Len(xChar1) < 15 And Mid(xChar1, 9, 1)="."
                ProcedureReturn 0
                ElseIf Right(xChar1, 9) = " - Winamp"
                xSize - 9
                PokeW(MemTxtTemp + xSize * 2, 0)
                EndIf
              EndIf
            EndIf
          EndIf
;CompilerIf 1
StrippedFO:
        If CompareMemory(MemTxtTemp, MemTxtOld, xSize * 2)
;Debug "FW: Unchanged"
          ProcedureReturn 1
          Else
;Debug "FW: Changed"
          RtlMoveMemory_(MemTxtOld, MemTxtTemp, xSize * 2)
          CompilerIf #LyricSupport
;Debug "Clear1"
            PokeW(MemTxtOldCalaymX, 0)
            ClearLyrics()
            CompilerEndIf
          If hIcon = hIconAP
            PokeL(*Success, TxtToBmp(hIcon, xSize, NowPlay, 11, 0, 0, 0))
            Else
            PokeL(*Success, TxtToBmp(hIcon, xSize, NowPlay, 12, 0, 0, 0))
            EndIf
          EndIf
;CompilerEndIf
        EndIf
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
CompilerElse
      EndIf
CompilerEndIf
    EndIf
  EndProcedure

CompilerIf #AnimPlugin
  Procedure AnimateFullWin(SkipFrame.l)
  CompilerElse
  Procedure AnimateFullWin()
  Define.l Panel
  CompilerEndIf
  Define.i Row
  Define.i Col
  Define.RECT xType1
  Define.i HasUpdatedPos
  CompilerIf #RenderSelf
    CompilerIf #MaxTick
      Static OldTick.l
      #MaxTickAND = #MaxTick - 1
      #MaxTickExp = #MaxTick * #MaxTick / 100
      CompilerEndIf
    CompilerEndIf

  ;CompilerIf #MMonitor ;= 2
    Define.RECT xType2
    ;CompilerEndIf
  Define.TextBmpType *Success
  Define.i xhBrush
  CompilerIf #SilvesterSupport
    Define.SYSTEMTIME xType3
    Define.s xChar1
    Define.s xChar2
    Define.l xBool1
    Define.l xBool2
    CompilerEndIf
  CompilerIf #LyricSupport
    Define.i xBool3
    CompilerEndIf

  xMainDC = GetDC_(xMainHWnd)
  If xMainDC
    Row = (GetTickCount_() & $3FFFFFFF)
    

CompilerIf #MMonitor; = 1
CompilerIf #FixedWidth
xType2\left = 0
xType2\top = 0
CompilerElse
    If SSPreview
      xType2\left = 0
      xType2\top = 0
      Else
      GetCursorPos_(@xType2)
      EndIf
CompilerEndIf
    If CompareMemory(@xType2, @LastMPos, 8) = 0
      RtlMoveMemory_(@LastMPos, @xType2, 8)
CompilerElse
CompilerIf #FixedWidth
xType1\left = 0
xType1\top = 0
CompilerElse
    If SSPreview
      xType2\left = 0
      xType2\top = 0
      Else
      GetCursorPos_(@xType1)
      EndIf
CompilerEndIf
    If CompareMemory(@xType1, @LastMPos, 8) = 0
      RtlMoveMemory_(@LastMPos, @xType1, 8)
CompilerEndIf
      LastMoved = Row
      If FakeSaverMode
        Goto DoSave
        Else
        ;Debug "0"
        Goto NoSave
        EndIf
      ;IsSaving = 0
      ;Goto NoProc
      Else
      If GetAsyncKeyState_($11)
;        xhBrush = 1
        If GetAsyncKeyState_($12) Or GetAsyncKeyState_($10)
          For Col = 0 To 255
            GetAsyncKeyState_(Col)
            Next
          LastMoved = Row
          If FakeSaverMode
            Goto DoSave
            Else
            Goto IgSave
            EndIf
          EndIf
        EndIf
      For Col = 0 To 255
        ;If (GetAsyncKeyState_(Col) & $80000001) = $80000001
        If (GetAsyncKeyState_(Col) & $8001) = $8001
          If Not (Col = $11 Or Col = $A2 Or Col = $A3) ; Or Col > $9F And Col < $A4)
            ;If Not (Col = $10 Or Col = $12) And hBrush
              For Col = Col + 1 To 255
                GetAsyncKeyState_(Col)
                Next
              
              LastMoved = Row
              If FakeSaverMode
                Goto DoSave
                Else
                Goto NoSave
                EndIf
            ;  EndIf
            EndIf
          EndIf
        Next
;      If xhBrush
;        If FakeSaverMode
;          Goto DoSave
;          Else
;          Debug "5"
;          Goto IgSave
;          EndIf
;        EndIf
      If FakeSaverMode
        FakeSaverMode = 0
        FakeSaverNow()
        ElseIf Row < LastMoved
        If Row + $40000000 > LastMoved + #TimeIntervalMs
          ;Debug "SaveVia1 - " + Str(Row) + ", " + Str(LastMoved)
          Goto DoSave
          ;IsSaving = 1
          Else
          ;Debug "NotElapsed1 - " + Str(Row) + ", " + Str(LastMoved)
;          LastMoved = Row
          ;Debug "2"
          Goto NoSave
          ;IsSaving = 0
          EndIf
        ElseIf Row > LastMoved + #TimeIntervalMs
        ;Debug "SaveVia2 - " + Str(Row) + ", " + Str(LastMoved)
DoSave:
        If IsSaving = 0
;********
          If NowHidden ; Or IsIconic_(xMainHWnd)
            HideSwap()
            ;NowHidden = 0
            ;RestoreTray()
            ;CompilerIf #PSFMode = 0
            ;  CompilerIf #SetToForeGround = #HWND_TOPMOST
            ;    SetWindowPos_(xMainHWnd, IsSaving * -2 + 1, 0, 0, 0, 0, #ReFlag2xxa)
            ;    CompilerEndIf
            ;  CompilerElse
            ;  SetWindowPos_(xMainHWnd, #SetToForeGround, 0, 0, 0, 0, #ReFlag2xxa)
            ;  CompilerEndIf
            EndIf
;********
          ShowCursor_(0)
          IsSaving = 1
          EndIf
        Else
        Goto IgSave
;        Debug "4"
        ;Debug "NotElapsed2 - " + Str(Row) + ", " + Str(LastMoved)
NoSave:
        If IsSaving
          ShowCursor_(1)
          IsSaving = 0
          EndIf
        EndIf
      EndIf
IgSave:
;NoProc:

;Debug "IsSaving: " + Str(IsSaving)

Global WasSaving.l

#SM_XVIRTUALSCREEN = 76
#SM_YVIRTUALSCREEN = 77
#SM_CXVIRTUALSCREEN = 78
#SM_CYVIRTUALSCREEN = 79    
;Debug MMonitor

    CompilerIf #MMonitor = 2

      GetWindowRect_(GetDesktopWindow_(), @xType1)
      Row = GetSystemMetrics_(#SM_CYVIRTUALSCREEN)
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      If EnumDisplayMonitors_(0, 0, @DMEnum2(), @Row)
CompilerElse
      If *EnumDisplayMonitors
        If CallFunctionFast(*EnumDisplayMonitors, 0, 0, @DMEnum2(), @Row)
          ;xType1\Top = GetSystemMetrics_(#SM_YVIRTUALSCREEN)
CompilerEndIf
          If Row
            xType1\Top = 0
            xType1\Left = GetSystemMetrics_(#SM_XVIRTUALSCREEN)
            xType1\Right = GetSystemMetrics_(#SM_CXVIRTUALSCREEN) ;+ xType1\Left
            xType1\Bottom = Row ;GetSystemMetrics_(#SM_CYVIRTUALSCREEN) ;+ xType1\Top
    ;          Debug "a: " + Str(xType1\Left) + ", " + Str(xType1\Right) + ", " + Str(xType1\Top) + ", " + Str(xType1\Bottom)
            GetWindowRect_(GetDesktopWindow_(), @xType2)
            If CompareMemory(@xType1, @xType2, SizeOf(xType1))
              Goto MMIsOK
              ElseIf xType1\Left + xType1\Right + xType1\Top + xType1\Bottom = 0
              Goto MMIsOK
              Else
              Goto IsMM
              EndIf
            ;Else
            ;Goto UseSecondary
            EndIf
          ;Else
          ;Goto UseSecondary
          EndIf
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
CompilerElse
        EndIf
CompilerEndIf
;UseSecondary:
      CompilerEndIf
    CompilerIf #MMonitor
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      If EnumDisplayMonitors_(0, 0, @DMEnum(), @xType1)
CompilerElse
      If *EnumDisplayMonitors
        ;Debug "Pre: "+Str(xType1\Left) + ", "+Str(xType1\Top)
        If CallFunctionFast(*EnumDisplayMonitors, 0, 0, @DMEnum(), @xType1)
CompilerEndIf
         ; Debug "Post: "+Str(xType1\Left) + ", "+Str(xType1\Top)
          If xType1\Left + xType1\Top = 0;+ xType1\Right + xType1\Bottom = 0
            ;Goto NoMM
            Else
            xType1\Right - xType1\Left
            xType1\Bottom - xType1\Top
            ;Debug "Is2"
            Goto IsMM
            EndIf
          ;Else
          ;Goto NoMM
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
CompilerElse
          EndIf
CompilerEndIf
        ;Else
        ;Goto NoMM
        EndIf
NoMM:
      CompilerEndIf

;Debug "NoMM?"
        If IsSaving
;        CompilerIf #FixedUse
          GetWindowRect_(GetDesktopWindow_(), @xType1)
;          CompilerElse
          Else
          SystemParametersInfo_(48, 0, @xType1, 0)
          EndIf
        xType1\Right - xType1\Left
        xType1\Bottom - xType1\Top
;;;      CompilerEndIf

MMIsOK:
IsMM:
CompilerIf #FixedWidth
  xType1\right = #FixedWidth
  xType1\bottom = #FixedHeight
CompilerEndIf


    If SSPreview
      GetClientRect_(SSPreview, @xType1)
      EndIf


;Debug "Try?"
    If Not CompareMemory(@xType1, @LastDeskPos, SizeOf(xType1))
;Debug "Chg!"
      RtlMoveMemory_(@LastDeskPos, @xType1, SizeOf(xType1))
      ;If hRegion: DeleteObject_(hRegion): EndIf
      ;hRegion = CreateRectRgn_(0, 0, xType1\Right, xType1\Bottom)

      CompilerIf #PSFMode
        CompilerIf #PSFSize > 0
          FullWindow_H = xType1\Bottom - #PSFSize)
          CompilerElse
          FullWindow_H = xType1\Bottom + xType1\Bottom / #PSFSize
          CompilerEndIf
        xType1\Top + FullWindow_H
        xType1\Bottom - FullWindow_H
        CompilerEndIf
      FullWindow_W = xType1\Right / 16
CompilerIf #FixedUse = 1
CompilerElse
      CompilerIf #HAlign = 1
        FullWindow_WMove = FullWindow_W * 2; / 
        CompilerElse
        FullWindow_WMove = FullWindow_W
        CompilerEndIf
CompilerEndIf

;FullWindow_W = xType1\Right
      FullWindow_H = (xType1\Bottom - #PicSizeYOX)  / 8
      #ReFlag2 = #SWP_NOACTIVATE | #SWP_SHOWWINDOW
      #ReFlag2x = #SWP_NOACTIVATE | #SWP_NOZORDER
      ;Debug Str(xType1\Left) + ", " + Str(xType1\Top) + ", " + Str(xType1\Right) + ", " + Str(xType1\Bottom)
CompilerIf #HiddenChk
If NowHidden = 0
  If HiddenCheck()
    HideSwap()
    EndIf
  EndIf
CompilerEndIf
      If NowHidden
;HookIt = 0
        CompilerIf #PSFMode = 0
          ;Debug "b: " + Str(xType1\Left) + ", " + Str(xType1\Right) + ", " + Str(xType1\Top) + ", " + Str(xType1\Bottom)
          SetWindowPos_(xMainHWnd, 0, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, #ReFlag2x)
          CompilerElse
          ;Debug "c: " + Str(xType1\Left) + ", " + Str(xType1\Right) + ", " + Str(xType1\Top) + ", " + Str(xType1\Bottom)
          SetWindowPos_(xMainHWnd, 0, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, #ReFlag2x)
          CompilerEndIf
        Else
        CompilerIf #PSFMode = 0
          ;Debug "d: " + Str(xType1\Left) + ", " + Str(xType1\Right) + ", " + Str(xType1\Top) + ", " + Str(xType1\Bottom)
          CompilerIf #SetToForeGround = #HWND_TOPMOST
            SetWindowPos_(xMainHWnd, IsSaving * -2 + 1, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, #ReFlag2)
            CompilerElse
            SetWindowPos_(xMainHWnd, -2, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, #ReFlag2)
            CompilerEndIf
          CompilerElse
          ;Debug "e: " + Str(xType1\Left) + ", " + Str(xType1\Right) + ", " + Str(xType1\Top) + ", " + Str(xType1\Bottom)
          SetWindowPos_(xMainHWnd, #SetToForeGround, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, #ReFlag2)
          CompilerEndIf
;HookIt = 1
        EndIf

      CompilerIf #FixedUse = 1
        CompilerElse
          CompilerIf #HAlign = 1
            FullWindowW = xType1\Right
            CompilerElse
            FullWindowH = xType1\Bottom
            CompilerEndIf
          NowResize()
        CompilerEndIf
      CompilerIf #RenderSelf
        ;ResizedSelf()
        ResizedSelf()
;SetWindowPos_(xMainHWnd, 1, 0, 0, 0, 0, #ReFlag2xxa)
;Define.l XXError
;Debug 1/XXError
        CompilerElse
        FillRect_(xMainDC, @xType1, hBrush)
        CompilerEndIf
      CompilerIf #FixedUse = 1
      CompilerElse
;        If gImage
;          ShowWindow_(gImage, 5)
;          EndIf
;        PaintSelf()
      CompilerEndIf
      ;ProcedureReturn
CompilerIf #SpectrumRedrawInfo
CompilerElse
      CalcAndDrawInfoPos()
CompilerEndIf
      WasSaving = IsSaving
      ElseIf Not WasSaving = IsSaving
;HookIt = 0
      CompilerIf #PSFMode = 0
        CompilerIf #SetToForeGround = #HWND_TOPMOST
          SetWindowPos_(xMainHWnd, IsSaving * -2 + 1, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, #ReFlag2)
          CompilerElse
          SetWindowPos_(xMainHWnd, -2, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, #ReFlag2)
          CompilerEndIf
        CompilerElse
        SetWindowPos_(xMainHWnd, #SetToForeGround, xType1\Left, xType1\Top, xType1\Right, xType1\Bottom, #ReFlag2)
        CompilerEndIf
;HookIt = 1
      WasSaving = IsSaving
      EndIf

    CompilerIf #SilvesterSupport
      ;If hIconSS
        GetLocalTime_(@xType3)
;xType3\wHour = 23
;xType3\wMonth = 12
;xType3\wDay = 31

        If xType3\wMonth = 12 And xType3\wDay = 31 And SSPreview = 0
          xChar2 = LoadResStringA(80)
          If xType3\wHour = 23
            If xType3\wMinute = 59
              Select xType3\wSecond
                Case 0 To 3, 15 To 18, 30 To 33, 45 To 49
                  xChar1 = ReplaceString(LoadResStringA(83), "$", Str(60 - Round(xType3\wSecond / 15, #PB_Round_Down) * 15))
                  xBool1 = 1
                Case 50 To 59
                  xChar1 = ReplaceString(LoadResStringA(86), "$", Str(60 - xType3\wSecond))
                  xChar2 = LoadResStringA(85)
                  If xType3\wSecond > 50
                    xBool2 = 1
                    EndIf
                  xBool1 = 1
                EndSelect
              ElseIf xType3\wSecond < 11
              Select xType3\wMinute
                Case 0, 15, 30, 45, 55 To 58
                  xChar1 = ReplaceString(LoadResStringA(82), "$", Str(60 - xType3\wMinute))
                  xBool1 = 1
                EndSelect
              EndIf
            ElseIf xType3\wHour > 12 And xType3\wSecond < 11
            If xType3\wMinute = 0
              xChar1 = ReplaceString(LoadResStringA(81), "$", Str(24 - xType3\wHour))
              xBool1 = 1
              EndIf
            EndIf
          ElseIf xType3\wMonth = 1 And xType3\wDay = 1
          If xType3\wHour = 0 And xType3\wMinute < 15
            xChar1 = ReplaceString(LoadResStringA(89), "$", Str(xType3\wYear))
            xChar2 = ReplaceString(LoadResStringA(88), "$", Str(xType3\wYear))
            xBool1 = 1
            ;xBool2 = 1
            EndIf
          EndIf

        CompilerIf #WarnMsg And #NoWarnOrQuitHack = 0
          CompilerIf #WarnQuit And #NoWarnOrQuitHack = 0
            If Not xBool1
              xBool1 = GetTickCount_() & $3FFFFFFF
              If xBool1 < WarnQuitTime
                xBool1 = #WarnQuit - (xBool1 + $40000000 - WarnQuitTime)
                Else
                xBool1 = #WarnQuit - (xBool1 - WarnQuitTime)
                EndIf
              xBool1 = xBool1 / 1000
              xChar2 = LoadResStringA(90)
              If xBool1 > 60
                Select (xBool1 % 60)
                  Case 0, 51 To 59
                    xChar1 = ReplaceString(LoadResStringA(92), "$", Str((xBool1 + 20) / 60))
                  Default
                    xBool1 = 0
                  EndSelect
                Else
                Select xBool1
                  Case 12 To 15, 27 To 30, 42 To 45, 57 To 60
                    xChar1 = ReplaceString(LoadResStringA(93), "$", Str(Round((xBool1 + 3) / 15, #PB_Round_Down) * 15))
                  Case -50 To 9
                    xChar1 = ReplaceString(LoadResStringA(96), "$", Str(xBool1))
                    xChar2 = LoadResStringA(95)
                    If xBool1 < 9
                      xBool2 = 1
                      EndIf
                  Default
                    xBool1 = 0
                  EndSelect
                EndIf
              ;xBool1 = 1
              EndIf
            CompilerEndIf
          CompilerEndIf


        If xBool1
          If OldSilversterTimerText = xChar1
            Goto SkipIsSame
            EndIf
          OldSilversterTimerText = xChar1
          MultiByteToWideChar_(0, 0, @xChar1, Len(xChar1), MemTxtOld, 255)
          *Success = TxtToBmp(hIconSS, Len(xChar1), xChar2, 1, 0, 0, 0)
          CompilerIf #LyricSupport
;Debug "Clear2"
            PokeW(MemTxtOldCalaymX, 0)
            ClearLyrics()
            CompilerEndIf
          If *Success
            Goto NoQPTitle
            EndIf
          EndIf
;            Debug OldSilversterTimerText + " / " + xChar1 + " / " + xChar2
        ;EndIf
      CompilerEndIf
    
;    ;If hIconQP
;      Row = FindWindow_("CalaymInterMsgClass100", "Calaym")
;      If Row
;        ;Define.l xLong3
;        PokeL(hMapFileViewQP, 0)
;        Col = SendMessage_(Row, #WM_COMMAND, 801, hMapFileID)
;        If Col
;          Debug Str(PeekB(hMapFileViewQP + (Col + 1) * 2 + 1)) + PeekS(hMapFileViewQP, -1, #PB_Unicode) + " " + Str(Col) + "/" + Str(Len(PeekS(hMapFileViewQP, -1, #PB_Unicode)))
;          If PeekB(hMapFileViewQP + (Col + 1) * 2 + 1) = 1
;            If CompareMemory(hMapFileViewQP, MemTxtOld, Col * 2)
;              Goto SkipIsSame
;              Else
;              RtlMoveMemory_(MemTxtOld, hMapFileViewQP, Col * 2)
;              *Success = TxtToBmp(hIconQP, Col, NowPlay, 10, 0, 0, 0)
;              EndIf
;            EndIf
;          EndIf
;        EndIf
;    ;  EndIf

    ;If hIconQP
    If SSPreview = 0
      Row = FindWindow_("CalaymInterMsgClass101", "Calaym")
      If Row
        PokeL(hMapFileViewQP, 0)
        Col = SendMessage_(Row, #WM_COMMAND, 805, hMapFileID) & $ffff
        If Col
          ;Debug PeekS(hMapFileViewQP, Col, #PB_Unicode)
CompilerIf #LyricSupport
          If CompareMemory(hMapFileViewQP, MemTxtOldCalaymX, Col << 1)
CompilerElse
          If CompareMemory(hMapFileViewQP, MemTxtOld, Col << 1)
CompilerEndIf
;Debug "Same1"
            ;*hBitmapTxt
            If *hBitmapTxt
              ;Debug "UpdatedPos: " + Str(PeekL(hMapFileViewQP + (Col << 1) + 4)) + "/" + Str(PeekL(hMapFileViewQP + (Col << 1) + 8))
              *hBitmapTxt\ProgCur = PeekL(hMapFileViewQP + (Col << 1) + 4)
              HasUpdatedPos = #True
CompilerIf #LyricSupport
Macro xTime(Min, Sec)
  (Min*60+Sec)*1000
  EndMacro

xBool1 = 0
Define.i xLong1 = PeekL(hMapFileViewQP + (Col << 1) + 4)
Define.i xLong2
Define.i xLong3 = -1
For xLong2 = 0 To LyricCount - 1
  If xLong1 < LyricTimes(xLong2)
    Break
    EndIf
  xLong3 = xLong2
  Next

xBool2 = 1
If Not xLong3 = -1
;Debug "LyricLine: " + Str(xLong3) + ": " + PeekS(LyricLines(xLong3) + 2, PeekW(LyricLines(xLong3)), #PB_Unicode)
  If LyricLines(xLong3)
    xBool1 = #True
    EndIf
  EndIf

;Debug Str(xLong1) + "->" + Str(xBool1) + "/" + Str(xBool2) + "/" + xChar1
If xBool1
  xBool3 = 1
  If OldLyricLine = xLong3
    Goto SkipIsSame
    EndIf
  OldLyricLine = xLong3
  ;MultiByteToWideChar_(0, 0, @OldLyricText, Len(OldLyricText), MemTxtOld, 255)
  RtlMoveMemory_(MemTxtOld, LyricLines(xLong3) + 2, PeekW(LyricLines(xLong3)) << 1)
  *Success = TxtToBmp(hIconQP, PeekW(LyricLines(xLong3)), " ", 1, xLong1, PeekL(hMapFileViewQP + (Col << 1) + 8), 0)
  If *Success
    *Success\Text1X + ((OldTxtLenX - *Success\Text2W) >> 1)
    *Success\Text2W = OldTxtLenX
    Goto NoQPTitle
    EndIf
  ElseIf Not OldLyricLine = -1
  OldLyricLine = -1
  xBool1 = #True
  Goto ReQPTitle
  EndIf
;RtlMoveMemory_(MemTxtOld, hMapFileViewQP, Col << 1)
;*Success = TxtToBmp(hIconQP, Col, NowPlay, 10, PeekL(hMapFileViewQP + (Col << 1) + 4), PeekL(hMapFileViewQP + (Col << 1) + 8))
CompilerEndIf
              EndIf
            Goto SkipIsSame
            Else
;Debug "UnSame"
ReQPTitle:
            CompilerIf #LyricSupport
              RtlMoveMemory_(MemTxtOldCalaymX, hMapFileViewQP, Col << 1)
              CompilerEndIf
            RtlMoveMemory_(MemTxtOld, hMapFileViewQP, Col << 1)
            If Not xBool1
              OldLyricWidthPX = ReadLyricFile(MemTxtOld, Col)
              EndIf
;Debug xLong3
            *Success = TxtToBmp(hIconQP, Col, NowPlay, 10, PeekL(hMapFileViewQP + (Col << 1) + 4), PeekL(hMapFileViewQP + (Col << 1) + 8), OldLyricWidthPX)
            CompilerIf #LyricSupport
              If *Success
                OldTxtLenX = *Success\Text2W
                EndIf
              OldLyricLine = -1
              xBool3 = #True
              CompilerEndIf
            CompilerIf #SilvesterSupport
              OldSilversterTimerText = ""
              CompilerEndIf
            EndIf
          EndIf
        EndIf
      EndIf
    ;  EndIf




CompilerIf #SilvesterSupport
NoQPTitle:
CompilerEndIf


;-  Lbl1
    If *Success = 0 And SSPreview = 0; hIconWA And Success = 0
;Debug "FindWA1"
      Row = FindWindow_("WinampShowTitlePluginClass", "Winamp")
      If Row
;Debug "FindWA1!"
        PokeL(hMapFileViewWA, 0)
        Col = SendMessage_(Row, #WM_COMMAND, 801, hMapFileID)
        If Col And Col < $150
          If CompareMemory(hMapFileViewWA, MemTxtOld, Col * 2)
            Goto SkipIsSame
            Else
            RtlMoveMemory_(MemTxtOld, hMapFileViewWA, Col * 2)
            CompilerIf #LyricSupport
;Debug "Clear3"
              PokeW(MemTxtOldCalaymX, 0)
              ClearLyrics()
              CompilerEndIf
            *Success = TxtToBmp(hIconWA, Col, NowPlay, 12, 0, 0, 0)
            EndIf
          EndIf
        EndIf
      EndIf

;Debug "FF0a:"
    If *Success = 0 And SSPreview = 0
;Debug "FF0b:"
      If FromWindow(FindWindow_("Winamp v1.x", 0), hIconWA, 1, @*Success): Goto SkipIsSame: EndIf
;Debug "FF0c:"
      If *Success = 0
;Debug "FF0d:"
        hWinFoobar = 0
        EnumWindows_(@FoobarFinder(), 0)
        If FromWindow(hWinFoobar, hIconFO, 1, @*Success): Goto SkipIsSame: EndIf
        EndIf
      EndIf



  If SSPreview
    If *Success
      DeleteTextObject(*Success)
      *Success = 0
      EndIf
    EndIf
CompilerIf #NoPlayerDet
  If *Success
    DeleteTextObject(*Success)
    *Success = 0
    EndIf
  CompilerEndIf


    
    CompilerIf #FixedUse = 1
      If *hBitmapTxt And Not *Success
        PicSizeXC = PicSizeXO
        PokeW(MemTxtOld, 0)
        CompilerIf #LyricSupport
;Debug "Clear5"
          PokeW(MemTxtOldCalaymX, 0)
          ClearLyrics()
          CompilerEndIf
        EndIf
      If *hBitmapTxt
        DeleteTextObject(*hBitmapTxt)
        EndIf
      *hBitmapTxt = *Success
CompilerIf #SpectrumRedrawInfo
CompilerElse
      CalcAndDrawInfoPos()
CompilerEndIf
      CompilerElse
      If *Success Or (*hBitmapTxt And Not *Success)
        hBitmapNxtWait = 1
        hBitmapNxtX = PicSizeX
        If Not *Success
          PokeW(MemTxtOld, 0)
          EndIf
        CompilerIf #LyricSupport
          If Not (xBool3)
;Debug "Clear6"
            PokeW(MemTxtOldCalaymX, 0)
            ClearLyrics()
            EndIf
          CompilerEndIf
        If *hBitmapNxt
          DeleteTextObject(*hBitmapNxt)
          EndIf
        *hBitmapNxt = *Success
        EndIf
      CompilerEndIf

  CompilerIf #SilvesterSupport
    If xBool2
      If *Success
        If *hBitmapTxt
          DeleteTextObject(*hBitmapTxt)
          EndIf
        *hBitmapTxt = *hBitmapNxt
        *hBitmapNxt = 0
        hBitmapNxtWait = 0
        CompilerIf #RenderMainInfoMySelf
          CompilerElse
            CalcAndDrawInfoPos()
          CompilerEndIf
        EndIf
      EndIf
    CompilerEndIf


SkipIsSame:

    CompilerIf #FixedUse = 1
      CompilerElse

;Debug "Next? :" + Str(hBitmapNxtWait)
;Debug "CurPos: " + Str(InfoLeft)
;      FullWindow_WMove = 16

; ClientToScreen / ScreenToClient this? :)

      If hBitmapNxtWait
        If InfoFirst
          ;InfoIs = InfoLeft
          ;InfoFirst = 0
          Goto NewIsNow
          EndIf
        CompilerIf #HAlign = 1
          If InfoIs > FullWindowW: InfoIs = FullWindowW: EndIf
          InfoIs - FullWindow_WMove
          CompilerElse
          If InfoIs < -PicSizeXC: InfoIs = -PicSizeXC: EndIf
          InfoIs + FullWindow_WMove
          CompilerEndIf
CompilerIf #HAlign = 1
        If InfoIs < InfoOut
          InfoIs = FullWindowW + InfoIs - InfoOut
CompilerElse
        If InfoIs > FullWindowH
          InfoIs = InfoIs - FullWindowH
CompilerEndIf
NewIsNow:
          If *hBitmapNxt
            PicSizeXC = hBitmapNxtX
            Else
            PicSizeXC = PicSizeXO
            EndIf
CompilerIf #HAlign = 1
          InfoOut = -PicSizeXC
CompilerElse
          InfoIs - PicSizeXC
;          InfoOut = -PicSizeXC
CompilerEndIf
          If *hBitmapTxt
            DeleteTextObject(*hBitmapTxt)
            EndIf
          *hBitmapTxt = *hBitmapNxt
          *hBitmapNxt = 0
          hBitmapNxtWait = 0
          NowResize()
          If InfoFirst
            CompilerIf #HAlign = 1
              InfoIs = InfoLeft
              CompilerElse
              InfoIs = InfoTop
              CompilerEndIf
            InfoFirst = 0
            EndIf
          EndIf
CompilerIf #SpectrumRedrawInfo
CompilerElse
;Debug "RedrawPosEx"
        CalcAndDrawInfoPos()
CompilerEndIf
CompilerIf #HAlign = 1
        ElseIf InfoIs > InfoLeft
        If InfoIs > FullWindowW: InfoIs = FullWindowW: EndIf
        InfoIs - FullWindow_WMove
        If InfoIs < InfoLeft: InfoIs = InfoLeft: EndIf
CompilerElse
        ElseIf InfoIs > InfoTop
        If InfoIs > FullWindowH: InfoIs = FullWindowH: EndIf
        InfoIs - FullWindow_WMove
        If InfoIs < InfoTop: InfoIs = InfoTop: EndIf
CompilerEndIf
CompilerIf #SpectrumRedrawInfo
CompilerElse
      CalcAndDrawInfoPos()
CompilerEndIf
CompilerIf #HAlign = 1
        ElseIf InfoIs < InfoLeft
CompilerElse
        ElseIf InfoIs < InfoTop
CompilerEndIf
        If InfoFirst
          CompilerIf #HAlign = 1
            InfoIs = InfoLeft
            InfoOut = -PicSizeXC
            CompilerElse
            InfoIs = InfoTop
            CompilerEndIf
          InfoFirst = 0
          Else
          CompilerIf #HAlign = 1
            InfoIs + FullWindow_WMove
            If InfoIs > InfoLeft: InfoIs = InfoLeft: EndIf
            CompilerElse
            InfoIs + FullWindow_WMove
            If InfoIs > InfoTop: InfoIs = InfoTop: EndIf
            CompilerEndIf
          EndIf
CompilerIf #SpectrumRedrawInfo
CompilerElse
        CalcAndDrawInfoPos()
CompilerEndIf
        ElseIf HasUpdatedPos
        CompilerIf #RenderMainInfoMySelf = 3
          DrawBmpCalcTextSizeEx(*hBitmapTxt, hDCTemp)
          CompilerElseIf #RenderMainInfoMySelf
          DrawBmpCalcTextSizeEx(*hBitmapTxt, hDCTemp)
          CompilerElse
          DrawBmpCalcTextSizeEx(*hBitmapTxt, xMainDC)
          CompilerEndIf
        EndIf
      CompilerEndIf



If NowHidden
  RenderTray()
;Debug "RenderTray"
  Row = CreateIconIndirect_(@hIS)
  If Row
;Debug "  CreatedIcon"
    TNotIcon\hIcon = Row
    TrayIconChanged()
    If RenderedTrayIcon
      DestroyIcon_(RenderedTrayIcon)
      EndIf
    RenderedTrayIcon = Row
    EndIf

  
Else
;DrawIconEx_(
;DrawIconEx_(xMainDC, 0, 0, RenderedTrayIcon, 16, 16, 0, 0, #DI_NORMAL)





    CompilerIf #RenderSelf
      CompilerIf #MaxTick
        Row = (GetTickCount_() & #MaxTickAND)
        RenderSelf(SkipFrame, (Row + #MaxTick - OldTick) & #MaxTickAND)
        OldTick = Row
        CompilerElse
        RenderSelf(SkipFrame)
        CompilerEndIf  
      CompilerElse
      CompilerIf #AnimPlugin = 0
        Define.f Boost = 1.5;00
        GetSpectrum(@xCurSpec(0), 3, 3, 2, @Boost)
        xCurSpec(0) * MaxInit / 100
        xCurSpec(1) * MaxInit / 100
        xCurSpec(2) * MaxInit / 100
        xCurSpec(3) * MaxInit / 100
        xCurSpec(4) * MaxInit / 100
        xCurSpec(5) * MaxInit / 100
  
        CompilerElse
        CompilerIf #AnimPlugin = 3
          GetSpectrum(@xCurSpec(0), #SpectrumArraySize, 2)
        For Row = 0 To #SpectrumArraySize * 2 - 1
          CompilerElse
          Define.f Boost = 0.35;00
          GetSpectrum(@xCurSpec(0), #SpectrumArraySize, 3, 2, @Boost)
        For Row = 0 To #SpectrumArraySize * #AnimPlugin - 1
          CompilerEndIf
  ;      For Row = 0 To #SpectrumArraySize * 2 - 1
  ;        Col = Row % #SpectrumArraySize
  ;        xCurSpec(Row) = xCurSpec(Row) / (1 / (Col * 4 * 32 / #SpectrumArraySize + 1)) ;* xBooster
          xCurSpec(Row) = xCurSpec(Row) * 4
          Next
        GetFrameFromSpectrum(SkipFrame, @xCurSpec(0), *xFrames)
        CompilerEndIf
CompilerSelect #AnimPlugin
  CompilerCase 0
      For Row = 0 To 15
        For Col = 0 To 3
          For Panel = 0 To 1
            RGBMulX(PeekL(*xFrames + (xCurrentFrame * 128 + Panel * 64 + Row * 4 + Col) * 4), Panel)
            xhBrush = CreateSolidBrush_(RGBMulX_Result)
  CompilerCase 3
      For Row = 0 To 1
        For Col = 0 To 15
            xhBrush = PeekL(*xFrames + (Row * 16 + Col) * 4)
            xhBrush = CreateSolidBrush_(xhBrush)
  CompilerDefault
      For Row = 0 To 7
        For Col = 0 To 15
            xhBrush = PeekL(*xFrames + (Row * 16 + Col) * 4)
            xhBrush = CreateSolidBrush_(xhBrush)
  CompilerEndSelect
            If Not xhBrush = 0
CompilerSelect #AnimPlugin
  CompilerCase 0
              xType1\Top = (Col + Panel * 4) * FullWindow_H + Panel * #PicSizeYOX
              xType1\Left = Row * FullWindow_W
  CompilerCase 1
              xType1\Top = (Row) * FullWindow_H + #PicSizeYOX
              xType1\Left = Col * FullWindow_W
  CompilerCase 2
              xType1\Top = (Row) * FullWindow_H + Round(Row / 4, 0)  * #PicSizeYOX
              xType1\Left = Col * FullWindow_W
  CompilerCase 3
              xType1\Top = Row * (FullWindow_H * 4 + #PicSizeYOX)
              xType1\Left = Col * FullWindow_W
  CompilerEndSelect
CompilerIf #AnimPlugin = 3
              xType1\Bottom = xType1\Top + 4 * FullWindow_H - 1
CompilerElse
              xType1\Bottom = xType1\Top + FullWindow_H - 1
CompilerEndIf
              xType1\Right = xType1\Left + FullWindow_W - 1
              FillRect_(xMainDC, xType1, xhBrush)
              DeleteObject_(xhBrush)
              EndIf
CompilerIf #AnimPlugin = 0
            Next
CompilerEndIf
          Next
        Next
      CompilerEndIf
EndIf
;    DrawFrameControl_(xMainDC, @xWinRectMin, #DFC_CAPTION, #DFCS_CAPTIONMIN)
;    DrawFrameControl_(xMainDC, @xWinRectClose, #DFC_CAPTION, #DFCS_CAPTIONCLOSE)

;    Define.l ll = CreateSolidBrush_($ff0000)
;    If ll
;      FillRect_(xMainDC, xWinRectClose, ll)
;      DeleteObject_(ll)
;      EndIf

    
    ReleaseDC_(xMainHWnd, xMainDC)
    EndIf

      If SSAutoQuit And Not IsSaving
        PostQuitMessage_(0)
        SSAutoQuit = #False
        EndIf


CompilerIf #AnimPlugin
  EndProcedure
  CompilerElse
  EndProcedure
  CompilerEndIf

Procedure TrayIconChanged()
  If SSPreview = 0 And SSAutoQuit = 0
    If HasIcon = 0
      Goto DoNeedAgain
      ElseIf Shell_NotifyIcon_(#NIM_MODIFY, @TNotIcon) = 0
      If Shell_NotifyIcon_(#NIM_DELETE, @TNotIcon)
DoNeedAgain:
        HasIcon = Shell_NotifyIcon_(#NIM_ADD, @TNotIcon)
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure.i LoadResData_WMF()
  Define.i xResult
  Define.i xLong1
  Define.i xLong2

  xLong1 = FindResource_(hInstance, @"systray", @"WMF")
  If xLong1
    xLong2 = LoadResource_(hInstance, xLong1)
    If xLong2
      xLong1 = SizeofResource_(hInstance, xLong1)
      If xLong1
        xLong2 = LockResource_(xLong2)
        If xLong2
          xResult = SetMetaFileBitsEx_(xLong1, xLong2)
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Macro WMFTray_QualityShift(Value)
  Value << 1
  ;(Value << 1)
  ;(Value * 3)
  EndMacro

Procedure.i WMFTray()
  Define.i xResult
  Define.i hDC2
  Define.i hBmp
  Define.i hBmpOld
  Define.RECT xType1
  Define.i hMeta

  hMeta = LoadResData_WMF()
  If hMeta
    hDC2 = GetDC_(0)
    If hDC2
      hBmp = CreateCompatibleBitmap_(hDC2, WMFTray_QualityShift(TrayIconSizeX), WMFTray_QualityShift(TrayIconSizeY))
      ReleaseDC_(0, hDC2)
      If hBmp
        hDC2 = CreateCompatibleDC_(0)
        If hDC2
          hBmpOld = SelectObject_(hDC2, hBmp)
          If hBmpOld
  Debug TrayIconSizeX
  Debug TrayIconSizeY
            xType1\right = WMFTray_QualityShift(TrayIconSizeX)
            xType1\bottom = WMFTray_QualityShift(TrayIconSizeY)
            FillRect_(hDC2, @xType1, hBrush)
            SetMapMode_(hDC2, #MM_ANISOTROPIC)
            SetViewportOrgEx_(hDC2, 0, 0, 0)
            SetViewportExtEx_(hDC2, WMFTray_QualityShift(TrayIconSizeX), WMFTray_QualityShift(TrayIconSizeY), 0)
            xResult = PlayMetaFile_(hDC2, hMeta)
            SetMapMode_(hDC2, #MM_TEXT)
            If xResult
              SetStretchBltMode_(hDCTemp, #HALFTONE)
              If StretchBlt_(hDCTemp, 0, 0, TrayIconSizeX, TrayIconSizeY, hDC2, 0, 0, WMFTray_QualityShift(TrayIconSizeX), WMFTray_QualityShift(TrayIconSizeY), #SRCCOPY)
              ;If BitBlt_(hDCTemp, 0, 0, TrayIconSizeX, TrayIconSizeY, hDC2, 0, 0, #SRCCOPY)
                xResult = #True
                EndIf
              SetStretchBltMode_(hDCTemp, 3)
              EndIf
            SelectObject_(hDC2, hBmpOld)
            EndIf
          DeleteDC_(hDC2)
          EndIf
        DeleteObject_(hBmp)
        EndIf
      EndIf
    DeleteMetaFile_(hMeta)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure RenderTray()
  Define.l xResult
  Define.l xLong1
  Define.l xLong2
  Define.f DPIScaleX = TrayIconSizeX / 16
  Define.f DPIScaleY = TrayIconSizeY / 16
;  Define *hMem
  ;iRect\Left = 1
  ;iRect\Right = 3

  Define.i TrayIconBarPosSP = 2.5 * DPIScaleX
  Define.i TrayIconBarWidth = TrayIconBarPosSP - Int(0.75 * DPIScaleX)
  Define.i TrayIconBarLeftP = (TrayIconSizeX - (4 * TrayIconBarPosSP + TrayIconBarWidth)) >> 1
  Define.i TrayIconBarRghtP = TrayIconBarLeftP + TrayIconBarWidth
  iRect\left = TrayIconBarLeftP
  iRect\right = TrayIconBarRghtP

  If SelectObject_(hDCTemp, hIS\hbmColor)
    ;LineSpec_GetSpectrum(@xTrayCurSpec(0), 5, 0, 2, 0)
    If SetWaveData(0)
      GetFullSpectrumMonoOpt(0)
      ;SpectrumOptimizeMono(0, 1024, 0)
      SpectrumCompactMono(0, 1024, @xTrayCurSpec(0), 5)
      EndIf
    For xLong1 = 0 To 4
    
      xResult = (13 - xTrayCurSpec(xLong1) * 20) * DPIScaleY
  ;Debug xCurSpec(xLong1)
      If xResult < 0: xResult = 0: EndIf
  ;    Debug xResult
      iRect\Top = DPIScaleY
      iRect\Bottom = DPIScaleY + xResult
      FillRect_(hDCTemp, @iRect, hBrush)
      iRect\Top = iRect\Bottom
      If iRect\Top < 4 * DPIScaleY
        iRect\Bottom = 4 * DPIScaleY
        FillRect_(hDCTemp, @iRect, hBrush_Red)
        iRect\Top = 4 * DPIScaleY
        EndIf
      If iRect\Top < 6 * DPIScaleY
        iRect\Bottom = 6 * DPIScaleY
        FillRect_(hDCTemp, @iRect, hBrush_Yellow)
        iRect\Top = 6 * DPIScaleY
        EndIf
      
      iRect\Bottom = 15 * DPIScaleY
      FillRect_(hDCTemp, @iRect, hBrush_Green)
      iRect\Left + TrayIconBarPosSP
      iRect\Right + TrayIconBarPosSP
      Next
    SelectObject_(hDCTemp, hLSBmpOld)
    EndIf
;  ProcedureReturn 1
  EndProcedure

CompilerIf #HiddenChk
CompilerIf #HiddenChk = 2
Procedure HiddenCheck()
CompilerElse
Procedure.i HiddenCheck()
  Define.i xResult
CompilerEndIf
  Define.i xLong1
  Define.POINT xType1
  
  If IsSaving = 0
    xLong1 = GetForegroundWindow_()
    If xLong1
      If IsWindowVisible_(xLong1)
        If GetClassName_(xLong1, @xType1, 8) = 7
          If xType1\X = $6B726F57
            If xType1\Y = $417265 Or xType1\Y = $577265
CompilerIf #HiddenChk = 2
;            Debug "Found"
CompilerElse
              xResult = xLong1
;              Debug "Found"
CompilerEndIf
              EndIf
            EndIf
          EndIf
;        If PeekS(@xType1, 7) = "WorkerA"
;          Debug "Found!!!"
;          Debug Hex(xType1\X)
;          Debug Hex(xType1\Y)
;          EndIf
;        EndIf
        EndIf
      EndIf
    EndIf
CompilerIf #HiddenChk = 2
CompilerElse
  ProcedureReturn xResult
CompilerEndIf
  EndProcedure
CompilerEndIf

Procedure RestoreTray()
  TNotIcon\hIcon = OrgTrayIcon
  TrayIconChanged()
  If RenderedTrayIcon
    DestroyIcon_(RenderedTrayIcon)
    RenderedTrayIcon = 0
    EndIf
  EndProcedure
;IncludeFile "Post.pb"

;LibBuild_Done()

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 1818
; FirstLine = 1811
; Folding = ---------------------------------------------
; EnableAsm
; Executable = C:\Q0511M\PROGRAMS\DEV\PUREB451\LSDemo.exe
; DisableDebugger
; CommandLine = /s
; CompileSourceDirectory
; AddResource = D:\DEV\Software\Libraries\LineSpec\LSDemo.rc